/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 28 "conf_parser.y" /* yacc.c:339  */


#define YY_NO_UNPUT
#include <sys/types.h>
#include <string.h>

#include "config.h"
#include "stdinc.h"
#include "ircd.h"
#include "list.h"
#include "conf.h"
#include "conf_class.h"
#include "event.h"
#include "log.h"
#include "client.h"	/* for UMODE_ALL only */
#include "irc_string.h"
#include "memory.h"
#include "modules.h"
#include "s_serv.h"
#include "hostmask.h"
#include "send.h"
#include "listener.h"
#include "resv.h"
#include "numeric.h"
#include "s_user.h"
#include "motd.h"
#include "hook.h"
#include "ssl.h"

#include <openssl/rsa.h>
#include <openssl/bio.h>
#include <openssl/pem.h>
#include <openssl/dh.h>

#include "rsa.h"

int yylex(void);

static struct
{
  struct {
    dlink_list list;
  } mask,
    leaf,
    hub;

  struct {
    char buf[IRCD_BUFSIZE];
  } name,
    user,
    host,
    addr,
    bind,
    file,
    cert,
    ca,
    profile,
    rpass,
    spass,
    class,
    reason;

  struct {
    unsigned int value;
  } flags,
    modes,
    snomask_local,
    snomask_remote,
    size,
    type,
    port,
    aftype,
    ping_freq,
    max_perip,
    con_freq,
    min_idle,
    max_idle,
    max_total,
    max_global,
    max_local,
    soft_sendq,
    flood_burst,
    flood_limit,
    max_sendq,
    max_recvq,
    cidr_bitlen_ipv4,
    cidr_bitlen_ipv6,
    number_per_cidr;

  struct
  {
    struct alias_entry *alias;
    struct sslprofile *ssl;
    struct sslprofile_identity *identity;
    struct dnsbl_entry *dnsbl;
  } ptr;
} block_state;

static void
reset_block_state(void)
{
  dlink_node *ptr = NULL, *ptr_next = NULL;

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.mask.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.mask.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.leaf.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.leaf.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.hub.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.hub.list);
    free_dlink_node(ptr);
  }

  memset(&block_state, 0, sizeof(block_state));
}


#line 195 "conf_parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_CONF_PARSER_H_INCLUDED
# define YY_YY_CONF_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACCEPT_PASSWORD = 258,
    ACCOUNT_WHOIS = 259,
    ADMIN = 260,
    AFTYPE = 261,
    ANTI_NICK_FLOOD = 262,
    ANTI_SPAM_EXIT_MESSAGE_TIME = 263,
    AUTOCONN = 264,
    BYTES = 265,
    KBYTES = 266,
    MBYTES = 267,
    CA_FILE = 268,
    CALLER_ID_WAIT = 269,
    CAN_FLOOD = 270,
    CHANNEL = 271,
    CIDR_BITLEN_IPV4 = 272,
    CIDR_BITLEN_IPV6 = 273,
    CIPHER_LIST = 274,
    CLASS = 275,
    CLOAK_KEY1 = 276,
    CLOAK_KEY2 = 277,
    CLOAK_KEY3 = 278,
    CLOAK_WHOIS_ACTUALLY = 279,
    CONNECT = 280,
    CONNECTFREQ = 281,
    CYCLE_ON_HOST_CHANGE = 282,
    DEFAULT_FLOODCOUNT = 283,
    DEFAULT_FLOODTIME = 284,
    DEFAULT_SPLIT_SERVER_COUNT = 285,
    DEFAULT_SPLIT_USER_COUNT = 286,
    DEFER = 287,
    DENY = 288,
    DESCRIPTION = 289,
    DIE = 290,
    DISABLE_AUTH = 291,
    DISABLE_CHMODES = 292,
    DISABLE_FAKE_CHANNELS = 293,
    DISABLE_REMOTE_COMMANDS = 294,
    DNSBL = 295,
    DNSBL_EXEMPT = 296,
    DOTS_IN_IDENT = 297,
    DURATION = 298,
    EMAIL = 299,
    ENABLE_EXTBANS = 300,
    ENABLE_FORWARDING = 301,
    ENCRYPTED = 302,
    EXCEED_LIMIT = 303,
    EXEMPT = 304,
    FAILED_OPER_NOTICE = 305,
    FLATTEN_LINKS = 306,
    FLOOD_BURST = 307,
    FLOOD_LIMIT = 308,
    GECOS = 309,
    GENERAL = 310,
    GLINE = 311,
    GLINE_DURATION = 312,
    GLINE_ENABLE = 313,
    GLINE_EXEMPT = 314,
    GLINE_MIN_CIDR = 315,
    GLINE_MIN_CIDR6 = 316,
    GLINE_REQUEST_DURATION = 317,
    HAVENT_READ_CONF = 318,
    HIDDEN = 319,
    HIDDEN_NAME = 320,
    HIDE_IDLE_FROM_OPERS = 321,
    HIDE_SERVER_IPS = 322,
    HIDE_SERVERS = 323,
    HIDE_SERVICES = 324,
    HIDE_SPOOF_IPS = 325,
    HOST = 326,
    HTTP = 327,
    HUB = 328,
    HUB_MASK = 329,
    IDENTITY = 330,
    IGNORE_BOGUS_TS = 331,
    INVISIBLE_ON_CONNECT = 332,
    INVITE_THROTTLE = 333,
    IP = 334,
    IRCD_AUTH = 335,
    IRCD_FLAGS = 336,
    IRCD_SID = 337,
    JOIN_FLOOD_COUNT = 338,
    JOIN_FLOOD_TIME = 339,
    KILL = 340,
    KILL_CHASE_TIME_LIMIT = 341,
    KLINE = 342,
    KLINE_EXEMPT = 343,
    KLINE_REASON = 344,
    KNOCK_DELAY = 345,
    KNOCK_DELAY_CHANNEL = 346,
    LEAF_MASK = 347,
    T_LINK = 348,
    LINKS_DELAY = 349,
    LISTEN = 350,
    MASK = 351,
    MATCH = 352,
    MAX_ACCEPT = 353,
    MAX_BANS = 354,
    MAX_CHANS_PER_OPER = 355,
    MAX_CHANS_PER_USER = 356,
    MAX_GLOBAL = 357,
    MAX_IDLE = 358,
    MAX_LOCAL = 359,
    MAX_NICK_CHANGES = 360,
    MAX_NICK_LENGTH = 361,
    MAX_NICK_TIME = 362,
    MAX_NUMBER = 363,
    MAX_TARGETS = 364,
    MAX_TOPIC_LENGTH = 365,
    MAX_WATCH = 366,
    MIN_IDLE = 367,
    MIN_NONWILDCARD = 368,
    MIN_NONWILDCARD_SIMPLE = 369,
    MODULE = 370,
    MODULES = 371,
    MOTD = 372,
    NAME = 373,
    NEED_ACCOUNT = 374,
    NEED_IDENT = 375,
    NEED_PASSWORD = 376,
    NETWORK_DESC = 377,
    NETWORK_NAME = 378,
    NICK = 379,
    NICK_COLLIDE_REALHOST = 380,
    NO_CREATE_ON_SPLIT = 381,
    NO_JOIN_ON_SPLIT = 382,
    NO_OPER_FLOOD = 383,
    NO_TILDE = 384,
    NUMBER = 385,
    NUMBER_PER_CIDR = 386,
    NUMBER_PER_IP = 387,
    OPER_ONLY = 388,
    OPER_ONLY_UMODES = 389,
    OPER_PASS_RESV = 390,
    OPER_SNOMASKS = 391,
    OPER_UMODES = 392,
    OPERATOR = 393,
    OPERS_BYPASS_CALLERID = 394,
    PACE_WAIT = 395,
    PACE_WAIT_SIMPLE = 396,
    PASSWORD = 397,
    PATH = 398,
    PING_COOKIE = 399,
    PING_TIME = 400,
    PORT = 401,
    QSTRING = 402,
    QUIET_ON_BAN = 403,
    RANDOM_IDLE = 404,
    REASON = 405,
    REDIRPORT = 406,
    REDIRSERV = 407,
    REHASH = 408,
    REMOTE = 409,
    REMOTEBAN = 410,
    RESV = 411,
    RESV_EXEMPT = 412,
    RSA_PRIVATE_KEY_FILE = 413,
    RSA_PUBLIC_KEY_FILE = 414,
    SCRIPT = 415,
    SECONDS = 416,
    MINUTES = 417,
    HOURS = 418,
    DAYS = 419,
    WEEKS = 420,
    MONTHS = 421,
    YEARS = 422,
    SEND_PASSWORD = 423,
    SENDQ = 424,
    SERVERHIDE = 425,
    SERVERINFO = 426,
    SERVER_NAME = 427,
    SESSION = 428,
    SHORT_MOTD = 429,
    T_SNOMASKS = 430,
    SOFT_SENDQ = 431,
    SPOOF = 432,
    SPOOF_NOTICE = 433,
    SQUIT = 434,
    SSL_CERTIFICATE_FILE = 435,
    SSL_CERTIFICATE_FINGERPRINT = 436,
    SSL_CONNECTION_REQUIRED = 437,
    SSL_DH_ELLIPTIC_CURVE = 438,
    SSL_DH_PARAM_FILE = 439,
    SSL_MESSAGE_DIGEST_ALGORITHM = 440,
    STATS_E_DISABLED = 441,
    STATS_I_OPER_ONLY = 442,
    STATS_K_OPER_ONLY = 443,
    STATS_M_OPER_ONLY = 444,
    STATS_O_OPER_ONLY = 445,
    STATS_P_OPER_ONLY = 446,
    STATS_U_OPER_ONLY = 447,
    T_ALIAS = 448,
    T_ALL = 449,
    T_BOTS = 450,
    T_CALLERID = 451,
    T_CCONN = 452,
    T_CLUSTER = 453,
    T_DEAF = 454,
    T_DEBUG = 455,
    T_DLINE = 456,
    T_FARCONNECT = 457,
    T_FILE = 458,
    T_FULL = 459,
    T_HIDECHANNELS = 460,
    T_GLOBOPS = 461,
    T_INVISIBLE = 462,
    T_IPV4 = 463,
    T_IPV6 = 464,
    T_LOCOPS = 465,
    T_LOG = 466,
    T_MAX_CLIENTS = 467,
    T_NCHANGE = 468,
    T_NOCTCP = 469,
    T_NONONREG = 470,
    T_OPERWALL = 471,
    T_RECVQ = 472,
    T_REJ = 473,
    T_RESTART = 474,
    T_SASL_NAME = 475,
    T_SERVER = 476,
    T_SERVICE = 477,
    T_SERVICES_NAME = 478,
    T_SERVNOTICE = 479,
    T_SET = 480,
    T_SHARED = 481,
    T_SIZE = 482,
    T_SKILL = 483,
    T_SOFTCALLERID = 484,
    T_SPY = 485,
    T_SSL = 486,
    SSLPROFILE = 487,
    SSL_PROFILE = 488,
    T_UMODES = 489,
    T_UNAUTH = 490,
    T_UNDLINE = 491,
    T_UNLIMITED = 492,
    T_UNRESV = 493,
    T_UNXLINE = 494,
    T_WALLOP = 495,
    T_WALLOPS = 496,
    T_WALLUSERS = 497,
    T_WEBIRC = 498,
    TBOOL = 499,
    THROTTLE_NUM = 500,
    THROTTLE_TIME = 501,
    TKLINE_EXPIRE_NOTICES = 502,
    TMASKED = 503,
    TS_MAX_DELTA = 504,
    TS_WARN_DELTA = 505,
    TWODOTS = 506,
    TYPE = 507,
    UNKLINE = 508,
    USE_LOGGING = 509,
    USE_TARGET_CHANGE = 510,
    USER = 511,
    VHOST = 512,
    VHOST6 = 513,
    WARN_NO_NLINE = 514,
    WLINE = 515,
    XLINE = 516
  };
#endif
/* Tokens.  */
#define ACCEPT_PASSWORD 258
#define ACCOUNT_WHOIS 259
#define ADMIN 260
#define AFTYPE 261
#define ANTI_NICK_FLOOD 262
#define ANTI_SPAM_EXIT_MESSAGE_TIME 263
#define AUTOCONN 264
#define BYTES 265
#define KBYTES 266
#define MBYTES 267
#define CA_FILE 268
#define CALLER_ID_WAIT 269
#define CAN_FLOOD 270
#define CHANNEL 271
#define CIDR_BITLEN_IPV4 272
#define CIDR_BITLEN_IPV6 273
#define CIPHER_LIST 274
#define CLASS 275
#define CLOAK_KEY1 276
#define CLOAK_KEY2 277
#define CLOAK_KEY3 278
#define CLOAK_WHOIS_ACTUALLY 279
#define CONNECT 280
#define CONNECTFREQ 281
#define CYCLE_ON_HOST_CHANGE 282
#define DEFAULT_FLOODCOUNT 283
#define DEFAULT_FLOODTIME 284
#define DEFAULT_SPLIT_SERVER_COUNT 285
#define DEFAULT_SPLIT_USER_COUNT 286
#define DEFER 287
#define DENY 288
#define DESCRIPTION 289
#define DIE 290
#define DISABLE_AUTH 291
#define DISABLE_CHMODES 292
#define DISABLE_FAKE_CHANNELS 293
#define DISABLE_REMOTE_COMMANDS 294
#define DNSBL 295
#define DNSBL_EXEMPT 296
#define DOTS_IN_IDENT 297
#define DURATION 298
#define EMAIL 299
#define ENABLE_EXTBANS 300
#define ENABLE_FORWARDING 301
#define ENCRYPTED 302
#define EXCEED_LIMIT 303
#define EXEMPT 304
#define FAILED_OPER_NOTICE 305
#define FLATTEN_LINKS 306
#define FLOOD_BURST 307
#define FLOOD_LIMIT 308
#define GECOS 309
#define GENERAL 310
#define GLINE 311
#define GLINE_DURATION 312
#define GLINE_ENABLE 313
#define GLINE_EXEMPT 314
#define GLINE_MIN_CIDR 315
#define GLINE_MIN_CIDR6 316
#define GLINE_REQUEST_DURATION 317
#define HAVENT_READ_CONF 318
#define HIDDEN 319
#define HIDDEN_NAME 320
#define HIDE_IDLE_FROM_OPERS 321
#define HIDE_SERVER_IPS 322
#define HIDE_SERVERS 323
#define HIDE_SERVICES 324
#define HIDE_SPOOF_IPS 325
#define HOST 326
#define HTTP 327
#define HUB 328
#define HUB_MASK 329
#define IDENTITY 330
#define IGNORE_BOGUS_TS 331
#define INVISIBLE_ON_CONNECT 332
#define INVITE_THROTTLE 333
#define IP 334
#define IRCD_AUTH 335
#define IRCD_FLAGS 336
#define IRCD_SID 337
#define JOIN_FLOOD_COUNT 338
#define JOIN_FLOOD_TIME 339
#define KILL 340
#define KILL_CHASE_TIME_LIMIT 341
#define KLINE 342
#define KLINE_EXEMPT 343
#define KLINE_REASON 344
#define KNOCK_DELAY 345
#define KNOCK_DELAY_CHANNEL 346
#define LEAF_MASK 347
#define T_LINK 348
#define LINKS_DELAY 349
#define LISTEN 350
#define MASK 351
#define MATCH 352
#define MAX_ACCEPT 353
#define MAX_BANS 354
#define MAX_CHANS_PER_OPER 355
#define MAX_CHANS_PER_USER 356
#define MAX_GLOBAL 357
#define MAX_IDLE 358
#define MAX_LOCAL 359
#define MAX_NICK_CHANGES 360
#define MAX_NICK_LENGTH 361
#define MAX_NICK_TIME 362
#define MAX_NUMBER 363
#define MAX_TARGETS 364
#define MAX_TOPIC_LENGTH 365
#define MAX_WATCH 366
#define MIN_IDLE 367
#define MIN_NONWILDCARD 368
#define MIN_NONWILDCARD_SIMPLE 369
#define MODULE 370
#define MODULES 371
#define MOTD 372
#define NAME 373
#define NEED_ACCOUNT 374
#define NEED_IDENT 375
#define NEED_PASSWORD 376
#define NETWORK_DESC 377
#define NETWORK_NAME 378
#define NICK 379
#define NICK_COLLIDE_REALHOST 380
#define NO_CREATE_ON_SPLIT 381
#define NO_JOIN_ON_SPLIT 382
#define NO_OPER_FLOOD 383
#define NO_TILDE 384
#define NUMBER 385
#define NUMBER_PER_CIDR 386
#define NUMBER_PER_IP 387
#define OPER_ONLY 388
#define OPER_ONLY_UMODES 389
#define OPER_PASS_RESV 390
#define OPER_SNOMASKS 391
#define OPER_UMODES 392
#define OPERATOR 393
#define OPERS_BYPASS_CALLERID 394
#define PACE_WAIT 395
#define PACE_WAIT_SIMPLE 396
#define PASSWORD 397
#define PATH 398
#define PING_COOKIE 399
#define PING_TIME 400
#define PORT 401
#define QSTRING 402
#define QUIET_ON_BAN 403
#define RANDOM_IDLE 404
#define REASON 405
#define REDIRPORT 406
#define REDIRSERV 407
#define REHASH 408
#define REMOTE 409
#define REMOTEBAN 410
#define RESV 411
#define RESV_EXEMPT 412
#define RSA_PRIVATE_KEY_FILE 413
#define RSA_PUBLIC_KEY_FILE 414
#define SCRIPT 415
#define SECONDS 416
#define MINUTES 417
#define HOURS 418
#define DAYS 419
#define WEEKS 420
#define MONTHS 421
#define YEARS 422
#define SEND_PASSWORD 423
#define SENDQ 424
#define SERVERHIDE 425
#define SERVERINFO 426
#define SERVER_NAME 427
#define SESSION 428
#define SHORT_MOTD 429
#define T_SNOMASKS 430
#define SOFT_SENDQ 431
#define SPOOF 432
#define SPOOF_NOTICE 433
#define SQUIT 434
#define SSL_CERTIFICATE_FILE 435
#define SSL_CERTIFICATE_FINGERPRINT 436
#define SSL_CONNECTION_REQUIRED 437
#define SSL_DH_ELLIPTIC_CURVE 438
#define SSL_DH_PARAM_FILE 439
#define SSL_MESSAGE_DIGEST_ALGORITHM 440
#define STATS_E_DISABLED 441
#define STATS_I_OPER_ONLY 442
#define STATS_K_OPER_ONLY 443
#define STATS_M_OPER_ONLY 444
#define STATS_O_OPER_ONLY 445
#define STATS_P_OPER_ONLY 446
#define STATS_U_OPER_ONLY 447
#define T_ALIAS 448
#define T_ALL 449
#define T_BOTS 450
#define T_CALLERID 451
#define T_CCONN 452
#define T_CLUSTER 453
#define T_DEAF 454
#define T_DEBUG 455
#define T_DLINE 456
#define T_FARCONNECT 457
#define T_FILE 458
#define T_FULL 459
#define T_HIDECHANNELS 460
#define T_GLOBOPS 461
#define T_INVISIBLE 462
#define T_IPV4 463
#define T_IPV6 464
#define T_LOCOPS 465
#define T_LOG 466
#define T_MAX_CLIENTS 467
#define T_NCHANGE 468
#define T_NOCTCP 469
#define T_NONONREG 470
#define T_OPERWALL 471
#define T_RECVQ 472
#define T_REJ 473
#define T_RESTART 474
#define T_SASL_NAME 475
#define T_SERVER 476
#define T_SERVICE 477
#define T_SERVICES_NAME 478
#define T_SERVNOTICE 479
#define T_SET 480
#define T_SHARED 481
#define T_SIZE 482
#define T_SKILL 483
#define T_SOFTCALLERID 484
#define T_SPY 485
#define T_SSL 486
#define SSLPROFILE 487
#define SSL_PROFILE 488
#define T_UMODES 489
#define T_UNAUTH 490
#define T_UNDLINE 491
#define T_UNLIMITED 492
#define T_UNRESV 493
#define T_UNXLINE 494
#define T_WALLOP 495
#define T_WALLOPS 496
#define T_WALLUSERS 497
#define T_WEBIRC 498
#define TBOOL 499
#define THROTTLE_NUM 500
#define THROTTLE_TIME 501
#define TKLINE_EXPIRE_NOTICES 502
#define TMASKED 503
#define TS_MAX_DELTA 504
#define TS_WARN_DELTA 505
#define TWODOTS 506
#define TYPE 507
#define UNKLINE 508
#define USE_LOGGING 509
#define USE_TARGET_CHANGE 510
#define USER 511
#define VHOST 512
#define VHOST6 513
#define WARN_NO_NLINE 514
#define WLINE 515
#define XLINE 516

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 157 "conf_parser.y" /* yacc.c:355  */

  int number;
  char *string;

#line 762 "conf_parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CONF_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 779 "conf_parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1578

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  268
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  344
/* YYNRULES -- Number of rules.  */
#define YYNRULES  757
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1513

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   516

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   266,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   267,   262,
       2,   265,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   264,     2,   263,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   422,   422,   423,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     455,   455,   456,   460,   464,   468,   472,   476,   480,   484,
     490,   490,   491,   492,   493,   494,   501,   500,   515,   515,
     516,   516,   516,   516,   516,   518,   531,   537,   543,   555,
     558,   558,   559,   559,   559,   559,   561,   567,   573,   581,
     580,   629,   629,   630,   630,   630,   631,   631,   632,   633,
     635,   643,   675,   701,   709,   718,   717,   739,   739,   740,
     740,   741,   742,   744,   759,   819,   860,   862,   862,   863,
     863,   864,   864,   865,   865,   866,   866,   867,   868,   869,
     870,   873,   888,   903,   912,   926,   935,   963,   993,  1018,
    1040,  1062,  1071,  1073,  1073,  1074,  1074,  1075,  1075,  1077,
    1086,  1095,  1108,  1107,  1125,  1125,  1126,  1126,  1126,  1128,
    1134,  1145,  1144,  1170,  1170,  1172,  1172,  1172,  1172,  1174,
    1180,  1186,  1187,  1187,  1188,  1213,  1214,  1214,  1216,  1216,
    1217,  1219,  1226,  1226,  1239,  1240,  1242,  1242,  1243,  1243,
    1245,  1253,  1256,  1262,  1261,  1267,  1267,  1268,  1272,  1276,
    1280,  1284,  1288,  1292,  1296,  1300,  1311,  1310,  1391,  1391,
    1392,  1392,  1392,  1393,  1393,  1393,  1393,  1394,  1394,  1395,
    1396,  1396,  1398,  1404,  1410,  1416,  1427,  1433,  1439,  1450,
    1457,  1456,  1462,  1462,  1463,  1464,  1469,  1474,  1479,  1484,
    1489,  1494,  1499,  1504,  1509,  1514,  1519,  1526,  1525,  1531,
    1531,  1533,  1538,  1543,  1548,  1553,  1558,  1563,  1568,  1573,
    1578,  1583,  1588,  1593,  1600,  1599,  1605,  1605,  1606,  1610,
    1614,  1618,  1622,  1626,  1630,  1634,  1638,  1642,  1646,  1650,
    1654,  1658,  1662,  1666,  1670,  1674,  1678,  1682,  1686,  1690,
    1694,  1698,  1702,  1706,  1710,  1721,  1720,  1778,  1778,  1779,
    1780,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,
    1788,  1788,  1788,  1788,  1789,  1790,  1791,  1792,  1794,  1800,
    1806,  1812,  1818,  1824,  1830,  1836,  1842,  1848,  1854,  1860,
    1867,  1873,  1879,  1885,  1894,  1904,  1903,  1909,  1909,  1910,
    1914,  1925,  1924,  1931,  1930,  1936,  1936,  1937,  1941,  1945,
    1949,  1953,  1959,  1959,  1960,  1960,  1960,  1960,  1960,  1960,
    1963,  1962,  1968,  1968,  1970,  1989,  2012,  2018,  2024,  2034,
    2033,  2098,  2098,  2099,  2099,  2099,  2099,  2100,  2100,  2100,
    2101,  2101,  2102,  2102,  2104,  2110,  2116,  2122,  2134,  2133,
    2139,  2139,  2140,  2144,  2148,  2152,  2156,  2160,  2164,  2168,
    2172,  2176,  2180,  2184,  2190,  2204,  2213,  2222,  2230,  2243,
    2242,  2257,  2257,  2258,  2258,  2258,  2258,  2260,  2266,  2272,
    2282,  2284,  2284,  2285,  2285,  2287,  2303,  2302,  2327,  2327,
    2328,  2328,  2328,  2328,  2330,  2336,  2356,  2355,  2361,  2361,
    2362,  2366,  2370,  2374,  2378,  2382,  2386,  2390,  2394,  2398,
    2402,  2406,  2416,  2415,  2436,  2436,  2437,  2437,  2437,  2439,
    2446,  2445,  2451,  2451,  2452,  2456,  2460,  2464,  2468,  2472,
    2476,  2480,  2484,  2488,  2498,  2497,  2584,  2584,  2585,  2585,
    2585,  2586,  2586,  2587,  2587,  2587,  2588,  2588,  2589,  2589,
    2589,  2590,  2590,  2591,  2593,  2599,  2605,  2611,  2624,  2637,
    2643,  2649,  2655,  2661,  2665,  2674,  2673,  2678,  2678,  2679,
    2683,  2689,  2700,  2706,  2712,  2723,  2722,  2748,  2748,  2749,
    2749,  2749,  2751,  2771,  2781,  2780,  2807,  2807,  2808,  2808,
    2808,  2810,  2816,  2825,  2827,  2827,  2828,  2828,  2830,  2848,
    2847,  2870,  2870,  2871,  2871,  2871,  2873,  2879,  2888,  2891,
    2891,  2892,  2892,  2893,  2893,  2894,  2894,  2895,  2895,  2896,
    2896,  2897,  2898,  2899,  2899,  2900,  2900,  2901,  2901,  2901,
    2902,  2902,  2903,  2904,  2904,  2905,  2906,  2906,  2907,  2907,
    2907,  2908,  2908,  2908,  2909,  2909,  2910,  2910,  2910,  2911,
    2911,  2912,  2913,  2913,  2914,  2914,  2915,  2916,  2917,  2918,
    2919,  2919,  2919,  2920,  2921,  2921,  2921,  2921,  2922,  2922,
    2922,  2923,  2923,  2923,  2924,  2927,  2932,  2938,  2947,  2956,
    2965,  2971,  2977,  2983,  2989,  2995,  3000,  3005,  3014,  3019,
    3024,  3029,  3034,  3039,  3044,  3049,  3054,  3059,  3064,  3069,
    3075,  3086,  3091,  3096,  3101,  3106,  3111,  3116,  3119,  3124,
    3127,  3132,  3137,  3142,  3147,  3152,  3157,  3162,  3167,  3172,
    3177,  3182,  3191,  3200,  3205,  3210,  3215,  3220,  3226,  3225,
    3230,  3235,  3240,  3252,  3252,  3253,  3257,  3261,  3265,  3269,
    3273,  3277,  3281,  3285,  3289,  3293,  3297,  3303,  3302,  3307,
    3307,  3309,  3313,  3317,  3321,  3325,  3329,  3333,  3337,  3341,
    3345,  3349,  3353,  3357,  3363,  3362,  3367,  3367,  3368,  3372,
    3376,  3380,  3384,  3388,  3392,  3396,  3400,  3404,  3408,  3412,
    3417,  3426,  3431,  3436,  3441,  3446,  3455,  3458,  3458,  3459,
    3460,  3460,  3461,  3461,  3462,  3463,  3464,  3465,  3466,  3466,
    3467,  3467,  3468,  3468,  3470,  3475,  3480,  3485,  3490,  3495,
    3500,  3505,  3510,  3515,  3520,  3525,  3530,  3535,  3543,  3546,
    3546,  3547,  3547,  3548,  3549,  3550,  3551,  3551,  3552,  3553,
    3555,  3561,  3567,  3573,  3579,  3588,  3602,  3608
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACCEPT_PASSWORD", "ACCOUNT_WHOIS",
  "ADMIN", "AFTYPE", "ANTI_NICK_FLOOD", "ANTI_SPAM_EXIT_MESSAGE_TIME",
  "AUTOCONN", "BYTES", "KBYTES", "MBYTES", "CA_FILE", "CALLER_ID_WAIT",
  "CAN_FLOOD", "CHANNEL", "CIDR_BITLEN_IPV4", "CIDR_BITLEN_IPV6",
  "CIPHER_LIST", "CLASS", "CLOAK_KEY1", "CLOAK_KEY2", "CLOAK_KEY3",
  "CLOAK_WHOIS_ACTUALLY", "CONNECT", "CONNECTFREQ", "CYCLE_ON_HOST_CHANGE",
  "DEFAULT_FLOODCOUNT", "DEFAULT_FLOODTIME", "DEFAULT_SPLIT_SERVER_COUNT",
  "DEFAULT_SPLIT_USER_COUNT", "DEFER", "DENY", "DESCRIPTION", "DIE",
  "DISABLE_AUTH", "DISABLE_CHMODES", "DISABLE_FAKE_CHANNELS",
  "DISABLE_REMOTE_COMMANDS", "DNSBL", "DNSBL_EXEMPT", "DOTS_IN_IDENT",
  "DURATION", "EMAIL", "ENABLE_EXTBANS", "ENABLE_FORWARDING", "ENCRYPTED",
  "EXCEED_LIMIT", "EXEMPT", "FAILED_OPER_NOTICE", "FLATTEN_LINKS",
  "FLOOD_BURST", "FLOOD_LIMIT", "GECOS", "GENERAL", "GLINE",
  "GLINE_DURATION", "GLINE_ENABLE", "GLINE_EXEMPT", "GLINE_MIN_CIDR",
  "GLINE_MIN_CIDR6", "GLINE_REQUEST_DURATION", "HAVENT_READ_CONF",
  "HIDDEN", "HIDDEN_NAME", "HIDE_IDLE_FROM_OPERS", "HIDE_SERVER_IPS",
  "HIDE_SERVERS", "HIDE_SERVICES", "HIDE_SPOOF_IPS", "HOST", "HTTP", "HUB",
  "HUB_MASK", "IDENTITY", "IGNORE_BOGUS_TS", "INVISIBLE_ON_CONNECT",
  "INVITE_THROTTLE", "IP", "IRCD_AUTH", "IRCD_FLAGS", "IRCD_SID",
  "JOIN_FLOOD_COUNT", "JOIN_FLOOD_TIME", "KILL", "KILL_CHASE_TIME_LIMIT",
  "KLINE", "KLINE_EXEMPT", "KLINE_REASON", "KNOCK_DELAY",
  "KNOCK_DELAY_CHANNEL", "LEAF_MASK", "T_LINK", "LINKS_DELAY", "LISTEN",
  "MASK", "MATCH", "MAX_ACCEPT", "MAX_BANS", "MAX_CHANS_PER_OPER",
  "MAX_CHANS_PER_USER", "MAX_GLOBAL", "MAX_IDLE", "MAX_LOCAL",
  "MAX_NICK_CHANGES", "MAX_NICK_LENGTH", "MAX_NICK_TIME", "MAX_NUMBER",
  "MAX_TARGETS", "MAX_TOPIC_LENGTH", "MAX_WATCH", "MIN_IDLE",
  "MIN_NONWILDCARD", "MIN_NONWILDCARD_SIMPLE", "MODULE", "MODULES", "MOTD",
  "NAME", "NEED_ACCOUNT", "NEED_IDENT", "NEED_PASSWORD", "NETWORK_DESC",
  "NETWORK_NAME", "NICK", "NICK_COLLIDE_REALHOST", "NO_CREATE_ON_SPLIT",
  "NO_JOIN_ON_SPLIT", "NO_OPER_FLOOD", "NO_TILDE", "NUMBER",
  "NUMBER_PER_CIDR", "NUMBER_PER_IP", "OPER_ONLY", "OPER_ONLY_UMODES",
  "OPER_PASS_RESV", "OPER_SNOMASKS", "OPER_UMODES", "OPERATOR",
  "OPERS_BYPASS_CALLERID", "PACE_WAIT", "PACE_WAIT_SIMPLE", "PASSWORD",
  "PATH", "PING_COOKIE", "PING_TIME", "PORT", "QSTRING", "QUIET_ON_BAN",
  "RANDOM_IDLE", "REASON", "REDIRPORT", "REDIRSERV", "REHASH", "REMOTE",
  "REMOTEBAN", "RESV", "RESV_EXEMPT", "RSA_PRIVATE_KEY_FILE",
  "RSA_PUBLIC_KEY_FILE", "SCRIPT", "SECONDS", "MINUTES", "HOURS", "DAYS",
  "WEEKS", "MONTHS", "YEARS", "SEND_PASSWORD", "SENDQ", "SERVERHIDE",
  "SERVERINFO", "SERVER_NAME", "SESSION", "SHORT_MOTD", "T_SNOMASKS",
  "SOFT_SENDQ", "SPOOF", "SPOOF_NOTICE", "SQUIT", "SSL_CERTIFICATE_FILE",
  "SSL_CERTIFICATE_FINGERPRINT", "SSL_CONNECTION_REQUIRED",
  "SSL_DH_ELLIPTIC_CURVE", "SSL_DH_PARAM_FILE",
  "SSL_MESSAGE_DIGEST_ALGORITHM", "STATS_E_DISABLED", "STATS_I_OPER_ONLY",
  "STATS_K_OPER_ONLY", "STATS_M_OPER_ONLY", "STATS_O_OPER_ONLY",
  "STATS_P_OPER_ONLY", "STATS_U_OPER_ONLY", "T_ALIAS", "T_ALL", "T_BOTS",
  "T_CALLERID", "T_CCONN", "T_CLUSTER", "T_DEAF", "T_DEBUG", "T_DLINE",
  "T_FARCONNECT", "T_FILE", "T_FULL", "T_HIDECHANNELS", "T_GLOBOPS",
  "T_INVISIBLE", "T_IPV4", "T_IPV6", "T_LOCOPS", "T_LOG", "T_MAX_CLIENTS",
  "T_NCHANGE", "T_NOCTCP", "T_NONONREG", "T_OPERWALL", "T_RECVQ", "T_REJ",
  "T_RESTART", "T_SASL_NAME", "T_SERVER", "T_SERVICE", "T_SERVICES_NAME",
  "T_SERVNOTICE", "T_SET", "T_SHARED", "T_SIZE", "T_SKILL",
  "T_SOFTCALLERID", "T_SPY", "T_SSL", "SSLPROFILE", "SSL_PROFILE",
  "T_UMODES", "T_UNAUTH", "T_UNDLINE", "T_UNLIMITED", "T_UNRESV",
  "T_UNXLINE", "T_WALLOP", "T_WALLOPS", "T_WALLUSERS", "T_WEBIRC", "TBOOL",
  "THROTTLE_NUM", "THROTTLE_TIME", "TKLINE_EXPIRE_NOTICES", "TMASKED",
  "TS_MAX_DELTA", "TS_WARN_DELTA", "TWODOTS", "TYPE", "UNKLINE",
  "USE_LOGGING", "USE_TARGET_CHANGE", "USER", "VHOST", "VHOST6",
  "WARN_NO_NLINE", "WLINE", "XLINE", "';'", "'}'", "'{'", "'='", "','",
  "':'", "$accept", "conf", "conf_item", "timespec_", "timespec",
  "sizespec_", "sizespec", "alias_entry", "$@1", "alias_items",
  "alias_item", "alias_name", "alias_user", "alias_host",
  "alias_oper_only", "modules_entry", "modules_items", "modules_item",
  "modules_module", "modules_script", "modules_path", "sslprofile", "$@2",
  "sslprofile_items", "sslprofile_item", "sslprofile_name",
  "sslprofile_dh_param_file", "sslprofile_dh_elliptic_curve",
  "sslprofile_cipher_list", "sslprofile_cafile", "sslprofile_identity",
  "$@3", "sslprofile_identity_items", "sslprofile_identity_item",
  "sslprofile_identity_server_name",
  "sslprofile_identity_rsa_private_key_file",
  "sslprofile_identity_certificate_file", "serverinfo_entry",
  "serverinfo_items", "serverinfo_item", "serverinfo_name",
  "serverinfo_sid", "serverinfo_description", "serverinfo_network_name",
  "serverinfo_network_desc", "serverinfo_vhost", "serverinfo_vhost6",
  "serverinfo_max_clients", "serverinfo_max_nick_length",
  "serverinfo_max_topic_length", "serverinfo_hub", "admin_entry",
  "admin_items", "admin_item", "admin_name", "admin_email",
  "admin_description", "motd_entry", "$@4", "motd_items", "motd_item",
  "motd_mask", "motd_file", "dnsbl_entry", "$@5", "dnsbl_items",
  "dnsbl_item", "dnsbl_name", "dnsbl_reason", "dnsbl_matches",
  "match_items", "match_item", "logging_entry", "logging_items",
  "logging_item", "logging_use_logging", "logging_file_entry", "$@6",
  "logging_file_items", "logging_file_item", "logging_file_name",
  "logging_file_size", "logging_file_type", "$@7",
  "logging_file_type_items", "logging_file_type_item", "oper_entry", "$@8",
  "oper_items", "oper_item", "oper_name", "oper_user", "oper_password",
  "oper_encrypted", "oper_rsa_public_key_file",
  "oper_ssl_certificate_fingerprint", "oper_ssl_connection_required",
  "oper_class", "oper_umodes", "$@9", "oper_umodes_items",
  "oper_umodes_item", "oper_snomasks", "$@10", "oper_snomasks_items",
  "oper_snomasks_item", "oper_flags", "$@11", "oper_flags_items",
  "oper_flags_item", "class_entry", "$@12", "class_items", "class_item",
  "class_name", "class_ping_time", "class_number_per_ip",
  "class_connectfreq", "class_max_number", "class_max_global",
  "class_max_local", "class_soft_sendq", "class_flood_burst",
  "class_flood_limit", "class_sendq", "class_recvq",
  "class_cidr_bitlen_ipv4", "class_cidr_bitlen_ipv6",
  "class_number_per_cidr", "class_min_idle", "class_max_idle",
  "class_flags", "$@13", "class_flags_items", "class_flags_item",
  "listen_entry", "$@14", "listen_flags", "$@15", "listen_flags_items",
  "listen_flags_item", "listen_items", "listen_item", "listen_port",
  "$@16", "port_items", "port_item", "listen_address", "listen_host",
  "listen_ssl_profile", "auth_entry", "$@17", "auth_items", "auth_item",
  "auth_user", "auth_passwd", "auth_class", "auth_encrypted", "auth_flags",
  "$@18", "auth_flags_items", "auth_flags_item", "auth_spoof",
  "auth_redir_serv", "auth_redir_port", "auth_ssl_certificate_fingerprint",
  "auth_ca_file", "resv_entry", "$@19", "resv_items", "resv_item",
  "resv_mask", "resv_reason", "resv_exempt", "service_entry",
  "service_items", "service_item", "service_name", "shared_entry", "$@20",
  "shared_items", "shared_item", "shared_name", "shared_user",
  "shared_type", "$@21", "shared_types", "shared_type_item",
  "cluster_entry", "$@22", "cluster_items", "cluster_item", "cluster_name",
  "cluster_type", "$@23", "cluster_types", "cluster_type_item",
  "connect_entry", "$@24", "connect_items", "connect_item", "connect_name",
  "connect_host", "connect_vhost", "connect_send_password",
  "connect_accept_password", "connect_ssl_certificate_fingerprint",
  "connect_ca_file", "connect_ssl_profile", "connect_port",
  "connect_aftype", "connect_flags", "$@25", "connect_flags_items",
  "connect_flags_item", "connect_encrypted", "connect_hub_mask",
  "connect_leaf_mask", "connect_class", "kill_entry", "$@26", "kill_items",
  "kill_item", "kill_user", "kill_reason", "deny_entry", "$@27",
  "deny_items", "deny_item", "deny_ip", "deny_reason", "exempt_entry",
  "exempt_items", "exempt_item", "exempt_ip", "gecos_entry", "$@28",
  "gecos_items", "gecos_item", "gecos_name", "gecos_reason",
  "general_entry", "general_items", "general_item", "general_max_watch",
  "general_cycle_on_host_change", "general_cloak_key1",
  "general_cloak_key2", "general_cloak_key3",
  "general_cloak_whois_actually", "general_account_whois",
  "general_gline_enable", "general_gline_duration",
  "general_gline_request_duration", "general_gline_min_cidr",
  "general_gline_min_cidr6", "general_kline_reason",
  "general_tkline_expire_notices", "general_kill_chase_time_limit",
  "general_hide_spoof_ips", "general_ignore_bogus_ts",
  "general_failed_oper_notice", "general_anti_nick_flood",
  "general_max_nick_time", "general_max_nick_changes",
  "general_max_accept", "general_anti_spam_exit_message_time",
  "general_ts_warn_delta", "general_ts_max_delta",
  "general_havent_read_conf", "general_invisible_on_connect",
  "general_warn_no_nline", "general_stats_e_disabled",
  "general_stats_o_oper_only", "general_stats_P_oper_only",
  "general_stats_u_oper_only", "general_stats_k_oper_only",
  "general_stats_i_oper_only", "general_stats_m_oper_only",
  "general_pace_wait", "general_caller_id_wait",
  "general_opers_bypass_callerid", "general_pace_wait_simple",
  "general_short_motd", "general_no_oper_flood", "general_oper_pass_resv",
  "general_dots_in_ident", "general_max_targets", "general_services_name",
  "general_sasl_name", "general_ping_cookie",
  "general_nick_collide_realhost", "general_disable_auth",
  "general_throttle_num", "general_throttle_time", "general_oper_umodes",
  "$@29", "general_enable_extbans", "general_enable_forwarding",
  "general_ssl_message_digest_algorithm", "umode_oitems", "umode_oitem",
  "general_oper_snomasks", "$@30", "snomask_oitems", "snomask_oitem",
  "general_oper_only_umodes", "$@31", "umode_items", "umode_item",
  "general_disable_chmodes", "general_use_target_change",
  "general_min_nonwildcard", "general_min_nonwildcard_simple",
  "general_default_floodcount", "general_default_floodtime",
  "channel_entry", "channel_items", "channel_item",
  "channel_disable_fake_channels", "channel_knock_delay",
  "channel_knock_delay_channel", "channel_max_chans_per_user",
  "channel_max_chans_per_oper", "channel_max_bans",
  "channel_default_split_user_count", "channel_default_split_server_count",
  "channel_no_create_on_split", "channel_no_join_on_split",
  "channel_jflood_count", "channel_jflood_time", "channel_quiet_on_ban",
  "channel_invite_throttle", "serverhide_entry", "serverhide_items",
  "serverhide_item", "serverhide_flatten_links",
  "serverhide_disable_remote_commands", "serverhide_hide_servers",
  "serverhide_hide_services", "serverhide_hidden_name",
  "serverhide_links_delay", "serverhide_hidden",
  "serverhide_hide_server_ips", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,    59,   125,   123,    61,    44,    58
};
# endif

#define YYPACT_NINF -895

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-895)))

#define YYTABLE_NINF -163

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -895,   761,  -895,  -153,  -239,  -237,  -895,  -895,  -895,  -895,
    -231,  -895,  -225,  -895,  -895,  -895,  -210,  -895,  -895,  -895,
    -199,  -197,  -895,  -895,  -194,  -191,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,    44,   878,  -181,  -171,  -168,
    -142,    13,  -132,   456,  -117,  -103,   -97,   239,   -86,   -81,
     -78,   357,   465,   -75,   -68,   119,    25,   -57,   -56,  -158,
     -48,   -37,   -18,    19,  -895,  -895,  -895,  -895,  -895,     0,
       3,    83,    97,   115,   124,   129,   137,   146,   150,   151,
     152,   153,   154,   211,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,   750,
     607,   175,   317,  -895,   155,     7,  -895,  -895,   197,  -895,
     158,   162,   163,   167,   168,   171,   173,   177,   180,   181,
     183,   184,   185,   188,   189,   190,   191,   193,   196,   206,
     208,   217,   221,   222,   223,   225,   230,   235,   242,   243,
     245,   246,   247,   250,   255,   256,   257,  -895,   259,  -895,
    -895,   260,   262,   264,   265,   269,   270,   271,   272,   274,
     275,   276,   279,   284,   286,   291,   293,   294,   295,   297,
     299,   301,   303,    14,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,   648,    31,
     298,    34,   307,   308,   311,   107,  -895,  -895,  -895,  -895,
      22,   508,   344,  -895,   312,   313,   314,   315,   320,   321,
     329,   333,    30,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,   103,   334,   336,   337,   339,   341,   342,   349,
     350,   351,   352,   353,   218,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,   105,    28,   200,
     354,     8,  -895,  -895,  -895,   194,  -895,   356,    45,  -895,
    -895,    79,   428,  -895,   292,   403,   435,   229,  -895,   282,
     374,   365,   492,   493,   492,   492,   492,   494,   495,   498,
     385,   387,   388,   389,  -895,   390,   391,   392,   393,   394,
     395,  -895,   397,   398,   399,   400,   401,   404,   405,   407,
     410,   415,   417,   419,   112,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,   423,   421,   422,   426,   427,   429,
     431,   433,  -895,   439,   442,   443,   444,   445,   447,   448,
     174,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,   449,   451,
      81,  -895,  -895,  -895,   455,   453,   462,   467,   135,  -895,
    -895,  -895,  -895,   506,   459,  -895,  -895,   470,   471,    16,
    -895,  -895,  -895,   411,   486,   492,   492,   546,   591,   592,
     496,   497,   615,   616,   503,   601,   619,   511,   512,   514,
     492,   519,   620,   622,   492,   635,   526,   528,   530,   492,
     631,   650,   652,   492,   653,   654,   655,   657,   545,   547,
     527,   549,   531,   532,   551,   492,   492,   554,   563,   661,
     565,  -232,  -214,   567,   568,   569,   573,   671,   672,   690,
     492,   577,   492,   492,   579,   580,   564,  -895,   566,   562,
     570,   571,  -895,   572,   574,   578,   582,   583,   584,   132,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,   585,   586,   101,  -895,  -895,  -895,   595,   594,
     596,  -895,   600,   602,  -895,   226,  -895,  -895,  -895,  -895,
    -895,  -895,   683,   686,   687,   598,  -895,   604,   605,   606,
     113,  -895,  -895,  -895,   610,   608,   609,  -895,   621,   624,
     625,  -895,   628,   629,  -895,   632,   209,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,   613,
     633,   636,   637,     9,  -895,  -895,  -895,  -895,   588,   640,
     641,   697,   656,   659,   662,   492,   618,  -895,  -895,   698,
     663,   722,   766,   775,   763,   764,   765,   783,   767,   776,
     660,  -895,   665,   668,   669,   673,   674,   100,  -895,  -895,
    -895,  -895,  -895,   675,   676,  -895,    54,  -895,  -895,  -895,
    -895,   680,   678,  -895,   666,   778,   691,  -895,   693,   679,
    -895,   692,    67,  -895,  -895,  -895,  -895,   696,   695,   699,
    -895,   700,   701,   705,   285,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,   713,   714,   718,  -895,   719,   720,   723,   785,
     724,   739,   740,   744,   748,   753,   754,   755,   759,   769,
     774,  -895,  -895,   833,   854,   492,   867,   897,   772,   908,
     492,   909,   910,   492,   895,   915,   917,   492,   918,   918,
     918,   787,  -895,  -895,   907,  -160,   911,   912,   811,   914,
     916,   792,   921,   922,   940,   927,   928,   930,   931,   817,
    -895,   933,   935,   821,  -895,  -895,   937,   938,   941,   827,
    -895,   828,  -895,   944,   945,   831,  -895,   832,   834,   837,
     838,   839,   840,   841,   842,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   855,   856,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   868,   869,   870,
     871,   872,   873,   874,   804,   875,   794,   836,   876,   877,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   896,   898,   899,   900,
     901,   902,  -895,  -895,   948,   951,   913,   903,   969,   989,
     982,   993,  1012,  1018,   904,  -895,  1020,  1022,   919,  -895,
    -895,  1023,  1024,   920,  1042,  1026,   924,  -895,   925,   926,
     929,  -895,  -895,  1027,  1028,   932,  -895,  -895,  1029,   934,
     936,  1030,  1032,  1033,   939,  1035,   946,   942,  1036,   943,
    -895,  -895,  1037,  1045,  1046,   947,  -895,   949,   950,   952,
     953,   954,   955,   956,   957,  -895,   958,   959,   960,   961,
     962,   963,   964,   965,   966,   967,   968,  -895,  -895,  1048,
     987,  1049,  1050,   970,  -895,  -895,  1051,   971,   972,  -895,
     973,  -895,   140,   975,  -895,  -895,  1052,   974,  1053,   976,
    -895,  -895,  1055,  1056,   977,  1059,  1061,  1063,   978,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,   492,   492,   492,   492,
     492,   492,   492,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,   980,   981,   983,   984,
     985,   -42,   986,   988,   990,   991,   992,   994,   995,   996,
     997,   375,   998,   999,  1000,  -895,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,    -5,  1009,  1010,  1011,  1013,  1014,
    1015,  1016,  -895,  1017,  1019,  -895,  -895,  -222,  -895,  1021,
    1025,  -895,  -895,  1031,  1034,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -205,  -895,  -895,  1038,  1039,
    1040,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -200,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -177,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  1041,  1047,
    1054,   685,  1057,  1058,  1060,  1062,  1064,  1065,  -895,  1066,
    1067,  -895,  1068,  1069,    15,  1043,   923,  -895,  1070,  -895,
    -895,  -895,  -895,  1071,  1072,  -895,  1073,  1074,   518,  1075,
    1076,  1077,   795,  1078,  1079,   857,  1080,  -895,  1081,  1082,
    1083,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  1084,  1085,  1086,  1087,  -895,  1088,   735,  -895,  -895,
    1089,   979,  1090,  -895,    51,  -895,  -895,  -895,  -895,  -895,
    1091,   682,  1092,  -895,  1094,  1095,    10,  1096,  1097,  1098,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -151,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,   918,   918,   918,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,   -71,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,   937,  -895,  -895,  -895,
    -895,  -895,   804,  1101,  1120,  1126,  -895,   794,  -895,   836,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,   -27,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,    77,  -895,  1103,  1042,  1099,  -895,  -895,  -895,
    -895,  -895,  -895,  1044,  -895,  -895,  1100,  -895,  -895,  -895,
    -895,  1102,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,    84,  -895,  -895,  -895,
    -895,  1104,  1105,  1106,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,    87,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,   138,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,   139,  -895,
    -895,  1135,  -111,  1109,  1108,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,   144,
    -895,  -895,  -895,  -895,  1113,  1111,  1112,  1114,    12,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,   -42,  -895,  -895,
    -895,  -895,    -5,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,   685,  -895,    15,  -895,  -895,  -895,  1130,  1131,  1132,
    -895,   518,  1134,  1136,  1137,  -895,   795,  -895,   857,  -895,
     735,  1116,  1118,  1119,   296,  -895,  -895,   682,  -895,  1142,
    1145,  1148,  1121,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
     147,  -895,  -895,  1122,  1123,  1124,  -895,  -895,   296,  -895,
    -895,  -895,  -895
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,   275,   454,   504,   141,
       0,   519,     0,   349,   495,   321,     0,   132,   186,   389,
       0,     0,    46,   432,     0,     0,   406,    69,     3,     5,
      24,    25,    12,     4,    26,    27,     6,     7,     9,    10,
      11,    14,    15,    16,    17,    18,    19,    20,    21,    23,
      22,     8,    13,    28,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   124,   125,   127,   126,   723,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   708,   720,   710,   711,   712,   713,
     709,   714,   715,   716,   717,   718,   719,   721,   722,     0,
       0,     0,     0,   517,     0,     0,   515,   516,     0,   594,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   684,     0,   667,
     648,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   530,   580,   583,   584,   585,   586,
     587,   588,   573,   574,   575,   576,   577,   578,   572,   541,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     568,   542,   543,   579,   545,   551,   552,   546,   548,   549,
     547,   560,   561,   550,   553,   554,   555,   544,   557,   581,
     582,   569,   570,   571,   566,   567,   558,   591,   592,   593,
     559,   556,   589,   590,   564,   565,   562,   563,     0,     0,
       0,     0,     0,     0,     0,     0,    61,    62,    63,    64,
       0,     0,     0,   749,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   740,   741,   742,   743,   744,   747,   745,
     746,   748,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    98,    99,   109,   102,   103,
     104,   100,   108,   105,   106,   107,   101,     0,     0,     0,
       0,     0,   157,   158,   159,     0,   404,     0,     0,   402,
     403,     0,     0,   128,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   707,     0,     0,     0,     0,     0,
       0,   315,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   278,   279,   282,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   280,   281,
     283,   294,   295,   296,     0,     0,     0,     0,     0,     0,
       0,     0,   485,     0,     0,     0,     0,     0,     0,     0,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     467,   466,   468,   472,   469,   470,   471,   510,     0,     0,
       0,   507,   508,   509,     0,     0,     0,     0,     0,   144,
     145,   146,   147,     0,     0,   514,   525,     0,     0,     0,
     522,   523,   524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   529,     0,     0,
       0,     0,   368,     0,     0,     0,     0,     0,     0,     0,
     352,   353,   354,   355,   360,   356,   357,   358,   359,   361,
     362,   501,     0,     0,     0,   498,   499,   500,     0,     0,
       0,   323,     0,     0,   335,     0,   333,   334,   336,   337,
     338,    65,     0,     0,     0,     0,    60,     0,     0,     0,
       0,   135,   136,   137,     0,     0,     0,   244,     0,     0,
       0,   227,     0,     0,   210,     0,     0,   189,   190,   191,
     192,   196,   197,   198,   199,   195,   193,   194,   200,     0,
       0,     0,     0,     0,   392,   393,   394,   395,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   739,   110,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    97,     0,     0,     0,     0,     0,     0,    49,    50,
      51,    52,    53,     0,     0,   440,     0,   435,   436,   437,
     160,     0,     0,   156,     0,     0,     0,   401,     0,     0,
     416,     0,     0,   409,   410,   411,   412,     0,     0,     0,
      85,     0,     0,     0,     0,    72,    73,    74,    75,    76,
      77,    78,     0,     0,     0,   122,     0,     0,     0,    30,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   706,   297,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   277,   473,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     456,     0,     0,     0,   506,   148,     0,     0,     0,     0,
     143,     0,   513,     0,     0,     0,   521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   528,   363,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   351,     0,     0,     0,   497,
     339,     0,     0,     0,     0,     0,     0,   332,     0,     0,
       0,    59,   138,     0,     0,     0,   134,   201,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     188,   396,     0,     0,     0,     0,   391,     0,     0,     0,
       0,     0,     0,     0,     0,   738,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    96,    54,     0,
       0,     0,     0,     0,    48,   438,     0,     0,     0,   434,
       0,   155,     0,     0,   400,   413,     0,     0,     0,     0,
     408,    79,     0,     0,     0,     0,     0,     0,     0,    71,
     131,   130,   129,   731,   730,   724,    30,    30,    30,    30,
      30,    30,    30,    32,    31,   737,   734,   735,   725,   726,
     729,   728,   727,   732,   733,   736,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,     0,   276,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   455,     0,     0,   505,   154,     0,   153,     0,
       0,   142,   518,     0,     0,   520,   601,   613,   617,   633,
     597,   598,   599,   600,   596,   704,   705,   645,   700,   639,
     650,   651,   612,   603,   602,   605,   606,   604,   620,   610,
     611,   621,   609,   607,   616,   615,   614,   640,   595,   702,
     703,   644,   637,   696,   689,   690,   693,   697,   688,   698,
     691,   692,   695,   699,   694,     0,   687,   638,   683,   672,
     674,   675,   677,   676,   679,   678,   681,   680,     0,   670,
     663,   656,   657,   660,   664,   655,   665,   658,   659,   662,
     666,   661,     0,   654,   634,   632,   635,   643,   636,   652,
     623,   629,   630,   627,   628,   631,   624,   625,   626,   642,
     641,   646,   647,   608,   619,   618,   701,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   350,     0,
       0,   496,     0,     0,     0,   344,   340,   343,     0,   322,
      66,    68,    67,     0,     0,   133,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   214,     0,   187,     0,     0,
       0,   390,   751,   750,   756,   754,   757,   752,   753,   755,
     113,   121,   112,   119,   120,   111,   115,   114,   118,   116,
     117,     0,     0,     0,     0,    47,     0,     0,   433,   161,
       0,     0,     0,   173,     0,   165,   166,   168,   167,   405,
       0,     0,     0,   407,     0,     0,     0,     0,     0,     0,
      70,    33,    34,    35,    36,    37,    38,    39,   310,   311,
     301,   306,   307,   320,   319,     0,   318,   303,   314,   304,
     302,   313,   298,   312,   300,   299,    40,    40,    40,    42,
      41,   308,   305,   309,   478,   483,   484,   480,   494,   491,
     475,   492,   489,   490,     0,   488,   493,   474,   482,   477,
     479,   481,   476,   511,   512,   151,     0,   149,   150,   526,
     527,   685,     0,     0,     0,     0,   668,     0,   649,     0,
     388,   366,   367,   377,   375,   373,   379,   374,   382,   376,
     383,   378,   380,   372,   381,     0,   371,   365,   386,   385,
     384,   387,   364,   503,   502,   347,   346,   331,   328,   330,
     329,   327,     0,   326,     0,     0,     0,   348,   139,   140,
     209,   205,   266,   253,   263,   262,   251,   256,   274,   265,
     272,   255,   258,   249,   268,   271,   250,   267,   264,   273,
     259,   261,   269,   270,   257,   260,     0,   247,   202,   204,
     206,   243,   232,   234,   235,   236,   238,   239,   237,   241,
     240,     0,   230,   207,   208,   223,   216,   217,   220,   224,
     215,   225,   218,   219,   222,   226,   221,     0,   213,   203,
     399,   397,   398,    55,    58,    57,    56,   439,   444,   450,
     453,   446,   452,   447,   451,   449,   445,   448,     0,   443,
     169,     0,     0,     0,     0,   164,   414,   420,   426,   429,
     431,   422,   428,   423,   427,   425,   421,   430,   424,     0,
     419,   415,    84,    83,     0,     0,     0,     0,     0,    88,
      89,    90,    91,    80,    82,    81,   316,     0,    43,    44,
      45,   486,     0,   152,   686,   682,   671,   673,   669,   653,
     369,     0,   324,     0,   345,   342,   341,     0,     0,     0,
     245,     0,     0,     0,     0,   228,     0,   211,   214,   441,
       0,     0,     0,     0,     0,   163,   417,     0,    92,     0,
       0,     0,     0,    87,   317,   487,   370,   325,   252,   248,
     254,   246,   242,   231,   233,   229,   212,   442,   170,   172,
     171,   179,   184,   183,   178,   181,   185,   182,   177,   180,
       0,   176,   418,     0,     0,     0,    86,   174,     0,    94,
      93,    95,   175
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -895,  -895,  -895,  -302,  -339,  -894,  -718,  -895,  -895,  -895,
     576,  -895,  -895,  -895,  -895,  -895,  -895,  1117,  -895,  -895,
    -895,  -895,  -895,  -895,   575,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -167,  -895,  -895,  -895,  -895,  -895,  1093,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  1214,  -895,  -895,  -895,  -895,  -895,  -895,
     728,  -895,  -895,  -895,  -895,  -895,  1107,  -895,  -895,  -895,
    -895,    43,  -895,  -895,  1110,  -895,  -895,  -895,  -895,   116,
    -895,  -895,  -895,  -895,  -895,  -207,  -895,  -895,  -895,   716,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -154,  -895,  -895,  -895,  -148,  -895,  -895,  -895,  -141,
    -895,  -895,  -895,  1115,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -115,  -895,  -895,  -895,  -895,  -895,
    -130,  -895,   760,  -895,  -895,  -895,    18,  -895,  -895,  -895,
    -895,  -895,  -895,   788,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -127,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
     715,  -895,  -895,  -895,  -895,  -895,  1125,  -895,  -895,  -895,
    -895,   702,  -895,  -895,  -895,  -895,  -895,  -146,  -895,  -895,
    -895,   706,  -895,  -895,  -895,  -895,  -135,  -895,  -895,  -895,
    1127,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,   -70,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,   819,  -895,  -895,  -895,  -895,  -895,  1128,  -895,
    -895,  -895,  -895,  1240,  -895,  -895,  -895,  -895,  1129,  -895,
    -895,  -895,  -895,  1173,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,    99,  -895,  -895,  -895,   120,  -895,  -895,  -895,   126,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  1286,  -895,
    -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895,  -895,  1133,  -895,  -895,  -895,  -895,
    -895,  -895,  -895,  -895
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    28,   943,   944,  1229,  1230,    29,    73,   637,
     638,   639,   640,   641,   642,    30,   265,   266,   267,   268,
     269,    31,    78,   674,   675,   676,   677,   678,   679,   680,
     681,   924,  1418,  1419,  1420,  1421,  1422,    32,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    33,    83,    84,    85,    86,    87,    34,    68,   570,
     571,   572,   573,    35,    60,   438,   439,   440,   441,   442,
     997,   998,    36,   321,   322,   323,   324,   325,  1184,  1185,
    1186,  1187,  1188,  1393,  1500,  1501,    37,    69,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   867,
    1367,  1368,   597,   864,  1351,  1352,   598,   860,  1336,  1337,
      38,    57,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   708,  1215,  1216,    39,    66,   554,   843,  1302,
    1303,   555,   556,   557,  1306,  1126,  1127,   558,   559,   560,
      40,    64,   529,   530,   531,   532,   533,   534,   535,   827,
    1285,  1286,   536,   537,   538,   539,   540,    41,    70,   603,
     604,   605,   606,   607,    42,   328,   329,   330,    43,    77,
     662,   663,   664,   665,   666,   917,  1409,  1410,    44,    74,
     646,   647,   648,   649,   907,  1388,  1389,    45,    58,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   731,  1244,  1245,   423,   424,   425,   426,    46,
      65,   544,   545,   546,   547,    47,    59,   430,   431,   432,
     433,    48,   125,   126,   127,    49,    62,   449,   450,   451,
     452,    50,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   493,   247,   248,   249,
    1082,  1083,   250,   492,  1068,  1069,   251,   490,  1055,  1056,
     252,   253,   254,   255,   256,   257,    51,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    52,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     972,   973,   974,   690,  1242,   692,   693,   694,   123,   319,
     599,  1414,   805,  1414,   123,   129,   806,   446,   130,   971,
      79,   131,   132,   567,  1213,    55,   326,    56,   133,   643,
     807,   273,   541,    61,   808,   134,   135,   136,   137,    63,
    1255,   138,   139,   140,  1256,    79,   326,  1297,   977,   978,
     141,   142,  1180,    80,    67,   643,   143,  1261,   600,   144,
     145,  1262,  1266,    81,   146,    71,  1267,    72,   658,   274,
      75,   147,   148,    76,   149,   150,   151,   152,    80,  1298,
     658,   275,   427,   119,   153,  1268,   124,  1299,    81,  1269,
     154,   155,   124,   120,   276,   277,   121,   278,   279,   280,
     156,   632,   541,   157,   333,   601,   632,  1214,   261,    53,
      54,  1426,   158,   355,   567,  1427,   759,   760,   568,   159,
     319,   160,   122,   161,   281,   162,  1462,   163,   164,   356,
     357,   774,   128,   518,   447,   778,   434,    82,   358,   165,
     783,  1180,   166,   327,   787,   519,   644,   258,   167,   168,
     169,   170,   520,   171,   172,   173,   799,   800,   174,   602,
     428,   259,    82,   327,   359,   360,   448,   260,  1415,  1181,
    1415,   816,   644,   818,   819,   394,   427,   395,   270,   521,
     396,   542,  1416,   271,  1416,   659,   272,   397,   175,   317,
    1417,  1431,  1417,   361,   398,  1432,   318,   659,   446,   176,
     177,   178,   179,   180,   181,   182,   183,   331,   332,   568,
     574,  -162,    88,   522,   362,   363,   364,   334,   633,   292,
     365,   399,   262,   633,   366,   569,  1243,   548,   335,   575,
     367,   429,   435,   634,   184,  1440,  1300,   185,   634,  1441,
     261,    89,    90,   368,   369,   400,  1301,   336,   401,    91,
     263,   542,   293,   436,   428,   402,   576,   370,  1181,   186,
     187,   188,   320,   189,   190,   339,   403,   264,   340,   191,
     444,   652,   875,   192,   523,  1472,   884,   516,  1182,   755,
     645,   371,   337,   524,   525,   437,   667,   543,   372,    92,
     577,   294,   404,   616,    93,    94,   561,   549,   668,   548,
     295,    95,    96,  1183,   669,   550,   645,   551,   656,   526,
      97,    98,    99,   527,  1394,   447,   569,   908,   434,   660,
     405,   635,  -162,   661,   296,   429,   635,   578,   297,   373,
     919,   660,  1428,  1429,  1430,   661,   298,   100,   101,  1442,
     299,   300,   406,  1443,   743,   599,  1450,   448,   341,  1455,
    1451,   579,  1491,  1456,   262,   407,   636,   543,   273,   102,
     670,   636,   342,   903,   838,   618,   958,  1182,   580,   549,
     565,   963,   552,   320,   966,   721,   855,   550,   970,   551,
     343,  1492,   263,  1493,   581,  1226,  1227,  1228,   528,   344,
     582,   583,  1183,   600,   345,   834,   274,   654,   749,   264,
    1457,  1459,   346,   671,  1458,  1460,  1466,   408,   275,  1507,
    1467,   347,   686,  1508,   435,   348,   349,   350,   351,   352,
     443,   276,   277,   453,   278,   279,   280,   454,   455,   667,
     301,   409,   456,   457,  1494,   436,   458,   739,   459,   682,
     601,   668,   460,   584,   552,   461,   462,   669,   463,   464,
     465,   281,  1495,   466,   467,   468,   469,   129,   470,   553,
     130,   471,   650,   131,   132,   585,   292,   437,   672,   673,
     133,   472,   869,   473,   353,   302,   303,   134,   135,   136,
     137,   630,   474,   138,   139,   140,   475,   476,   477,   846,
     478,   685,   141,   142,   602,   479,  1496,  1497,   143,   293,
     480,   144,   145,   670,   687,   971,   146,   481,   482,   574,
     483,   484,   485,   147,   148,   486,   149,   150,   151,   152,
     487,   488,   489,  1312,   491,   494,   153,   495,   575,   496,
     497,   553,   154,   155,   498,   499,   500,   501,   294,   502,
     503,   504,   156,  1313,   505,   157,   671,   295,   928,   506,
     683,   507,  1498,  1314,   158,   576,   508,  1499,   509,   510,
     511,   159,   512,   160,   513,   161,   514,   162,   515,   163,
     164,   296,   562,   563,  1315,   297,   564,   608,   609,   610,
     611,   165,   684,   298,   166,   612,   613,   299,   300,   577,
     167,   168,   169,   170,   614,   171,   172,   173,   615,   619,
     174,   620,   621,  1316,   622,  1317,   623,   624,   394,   688,
     395,   672,   673,   396,   625,   626,   627,   628,   629,   651,
     397,   655,   689,   691,   695,   696,   578,   398,   697,   698,
     175,   699,   700,  1318,  1201,  1202,  1203,  1204,  1205,  1206,
    1207,   176,   177,   178,   179,   180,   181,   182,   183,   518,
     579,   701,   702,   751,   399,   757,   703,   704,   705,   706,
     707,   519,   709,   710,   711,   712,   713,   580,   520,   714,
     715,  1319,   716,  1320,  1463,   717,   184,   301,   400,   185,
     718,   401,   719,   581,   720,   723,   724,   725,   402,   582,
     583,   726,   727,   761,   728,   521,   729,  1321,   730,   403,
    1273,   186,   187,   188,   732,   189,   190,   733,   734,   735,
     736,   191,   737,   738,   741,   192,   742,   745,   746,  1322,
    1323,   752,   302,   303,  1324,   404,  1274,   747,  1325,   522,
     758,  1326,   748,  1275,  1327,   753,   754,  1328,   762,   763,
     764,   765,   584,  1329,  1276,   766,   767,   768,   769,   770,
     776,   355,   777,   405,  1330,   771,   772,  1331,   773,  1332,
    1333,     2,     3,   775,   585,   779,     4,   356,   357,  1397,
     780,  1334,   781,  1277,   782,   406,   358,     5,   784,  1335,
     785,     6,   786,   788,   789,   790,     7,   791,   407,   792,
     523,   793,   794,   795,     8,   798,   796,   797,   801,   524,
     525,     9,   359,   360,  1278,  1279,  1280,   802,   803,   804,
      10,   809,   810,   811,  1281,    11,    12,   812,   813,   814,
     815,   817,  1378,   820,   821,   526,   822,   824,   823,   527,
     848,   361,   877,   849,   850,   825,   826,   828,  1398,   829,
     408,    13,  1282,   830,   880,   886,    14,   831,   832,   833,
     836,   837,   362,   363,   364,  1399,    15,   840,   365,   841,
     851,   842,   366,  1283,   409,   844,   852,   845,   367,   888,
     853,   854,   857,   858,   859,   871,  1400,    16,    17,    88,
     885,   368,   369,  1401,   878,   879,   861,  1058,  1341,   862,
     863,  1379,  1402,   865,   866,   370,   889,   868,   872,    18,
     881,   873,   874,   882,   528,   890,   883,   887,    89,    90,
     891,   892,   893,   894,   895,   689,    91,    19,  1403,   371,
    1404,  1405,   897,   896,   910,   913,   372,   898,  1284,  1380,
     912,    20,    21,   899,   900,  1406,  1381,   905,   901,   902,
     911,   906,  1407,  1408,   916,  1382,   936,   937,   938,   939,
     940,   941,   942,   914,    22,   915,    92,   918,   921,    23,
     922,    93,    94,   956,   923,   925,   926,   373,    95,    96,
     927,  1383,    24,  1384,  1385,   930,   931,    97,    98,    99,
     932,   933,   934,    25,   957,   935,   945,    26,  1386,  1059,
    1342,  1060,  1343,    27,  1061,  1344,  1387,   959,  1062,  1345,
    1043,   946,   947,  1044,   100,   101,   948,  1063,  1346,  1045,
     949,  1046,  1064,  1347,  1047,   950,   951,   952,  1048,  1049,
    1050,   953,  1065,  1348,  1066,  1349,   102,   960,  1051,  1067,
    1350,   954,  1070,  1052,  1053,  1071,   955,   961,   962,   964,
     965,  1072,   967,  1073,  1054,   968,  1074,   969,   971,   975,
    1075,  1076,  1077,  1355,   976,   981,  1356,   984,   979,   980,
    1078,   982,  1357,   983,  1358,  1079,  1080,  1359,   985,   986,
     987,  1360,  1361,  1362,   988,   989,  1081,   990,   991,   992,
     993,  1363,   994,   995,   996,   999,  1364,  1365,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1108,  1007,  1366,  1109,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1112,  1025,  1026,  1113,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1114,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1057,  1084,  1085,
    1115,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1110,  1102,  1116,
    1103,  1104,  1105,  1106,  1107,  1117,  1118,  1119,  1111,  1120,
    1122,  1123,  1125,  1128,  1133,  1134,  1136,  1139,  1137,  1140,
    1141,  1121,  1143,  1146,  1148,  1124,  1129,  1130,  1131,  1305,
    1144,  1132,  1149,  1150,  1135,  1171,  1173,  1174,  1176,  1190,
    1192,  1138,  1194,  1195,  1142,  1147,  1197,  1145,  1198,  1151,
    1199,  1152,  1153,   904,  1154,  1155,  1156,  1157,  1158,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,  1168,  1169,
    1170,  1172,  1175,  1444,  1178,  1179,  1177,  1189,  1193,  1191,
    1200,  1196,  1208,  1209,  1391,  1210,  1211,  1212,  1217,   929,
    1218,  1473,  1219,  1220,  1221,  1435,  1222,  1223,  1224,  1225,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,
    1241,  1246,  1247,  1248,  1436,  1249,  1250,  1251,  1252,  1253,
    1437,  1254,  1461,  1257,  1478,  1479,  1480,  1258,  1482,  1503,
    1483,  1484,  1504,  1259,  1304,  1505,  1260,   338,   856,  1433,
    1395,  1512,   870,  1270,  1486,  1263,  1264,  1265,  1485,  1271,
    1481,  1447,  1474,  1477,  1476,   847,  1272,   835,   876,  1287,
    1288,  1502,  1289,  1445,  1290,  1487,  1291,  1292,  1293,  1294,
    1295,  1296,  1307,  1308,  1309,  1310,  1311,  1338,  1339,  1340,
    1353,  1354,  1369,  1370,  1371,  1372,  1373,  1374,  1375,  1376,
    1377,  1390,   909,  1396,  1411,  1392,  1412,  1413,  1423,  1424,
    1425,  1446,  1475,   839,   920,   445,   517,  1448,  1439,  1449,
    1465,  1452,  1453,  1454,  1464,  1468,  1469,  1470,  1488,  1471,
    1489,  1490,   566,  1506,  1509,  1510,  1511,  1438,  1434,   354,
       0,     0,     0,     0,     0,     0,     0,   631,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   617,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   653,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   657,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   722,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   740,     0,     0,
       0,     0,     0,     0,     0,   750,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   744,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   756
};

static const yytype_int16 yycheck[] =
{
     718,   719,   720,   342,     9,   344,   345,   346,     1,     1,
       1,     1,   244,     1,     1,     1,   248,     1,     4,   130,
       1,     7,     8,     1,    66,   264,     1,   264,    14,     1,
     244,     1,     1,   264,   248,    21,    22,    23,    24,   264,
     262,    27,    28,    29,   266,     1,     1,    32,   208,   209,
      36,    37,     1,    34,   264,     1,    42,   262,    49,    45,
      46,   266,   262,    44,    50,   264,   266,   264,     1,    39,
     264,    57,    58,   264,    60,    61,    62,    63,    34,    64,
       1,    51,     1,   264,    70,   262,    79,    72,    44,   266,
      76,    77,    79,   264,    64,    65,   264,    67,    68,    69,
      86,     1,     1,    89,   262,    96,     1,   149,     1,   262,
     263,   262,    98,     1,     1,   266,   455,   456,    96,   105,
       1,   107,   264,   109,    94,   111,   237,   113,   114,    17,
      18,   470,   264,     1,   118,   474,     1,   118,    26,   125,
     479,     1,   128,   118,   483,    13,   118,   264,   134,   135,
     136,   137,    20,   139,   140,   141,   495,   496,   144,   150,
      79,   264,   118,   118,    52,    53,   150,   264,   158,   118,
     158,   510,   118,   512,   513,     1,     1,     3,   264,    47,
       6,   150,   172,   264,   172,   118,   264,    13,   174,   264,
     180,   262,   180,    81,    20,   266,   264,   118,     1,   185,
     186,   187,   188,   189,   190,   191,   192,   264,   264,    96,
       1,   203,     1,    81,   102,   103,   104,   265,   118,     1,
     108,    47,   115,   118,   112,   203,   231,     1,   265,    20,
     118,   150,    97,   133,   220,   262,   221,   223,   133,   266,
       1,    30,    31,   131,   132,    71,   231,   265,    74,    38,
     143,   150,    34,   118,    79,    81,    47,   145,   118,   245,
     246,   247,   254,   249,   250,   265,    92,   160,   265,   255,
     263,   263,   263,   259,   142,   263,   615,   263,   227,   263,
     252,   169,   263,   151,   152,   150,     1,   256,   176,    78,
      81,    73,   118,   263,    83,    84,   262,    71,    13,     1,
      82,    90,    91,   252,    19,    79,   252,    81,   263,   177,
      99,   100,   101,   181,   263,   118,   203,   263,     1,   252,
     146,   221,   203,   256,   106,   150,   221,   118,   110,   217,
     263,   252,  1226,  1227,  1228,   256,   118,   126,   127,   262,
     122,   123,   168,   266,   263,     1,   262,   150,   265,   262,
     266,   142,    56,   266,   115,   181,   256,   256,     1,   148,
      75,   256,   265,   263,   263,   262,   705,   227,   159,    71,
     263,   710,   146,   254,   713,   263,   263,    79,   717,    81,
     265,    85,   143,    87,   175,    10,    11,    12,   256,   265,
     181,   182,   252,    49,   265,   263,    39,   203,   263,   160,
     262,   262,   265,   118,   266,   266,   262,   233,    51,   262,
     266,   265,   130,   266,    97,   265,   265,   265,   265,   265,
     265,    64,    65,   265,    67,    68,    69,   265,   265,     1,
     212,   257,   265,   265,   138,   118,   265,   263,   265,   147,
      96,    13,   265,   234,   146,   265,   265,    19,   265,   265,
     265,    94,   156,   265,   265,   265,   265,     1,   265,   233,
       4,   265,   262,     7,     8,   256,     1,   150,   183,   184,
      14,   265,   263,   265,   263,   257,   258,    21,    22,    23,
      24,   263,   265,    27,    28,    29,   265,   265,   265,   263,
     265,   262,    36,    37,   150,   265,   200,   201,    42,    34,
     265,    45,    46,    75,   130,   130,    50,   265,   265,     1,
     265,   265,   265,    57,    58,   265,    60,    61,    62,    63,
     265,   265,   265,     5,   265,   265,    70,   265,    20,   265,
     265,   233,    76,    77,   265,   265,   265,   265,    73,   265,
     265,   265,    86,    25,   265,    89,   118,    82,   263,   265,
     147,   265,   256,    35,    98,    47,   265,   261,   265,   265,
     265,   105,   265,   107,   265,   109,   265,   111,   265,   113,
     114,   106,   265,   265,    56,   110,   265,   265,   265,   265,
     265,   125,   147,   118,   128,   265,   265,   122,   123,    81,
     134,   135,   136,   137,   265,   139,   140,   141,   265,   265,
     144,   265,   265,    85,   265,    87,   265,   265,     1,   244,
       3,   183,   184,     6,   265,   265,   265,   265,   265,   265,
      13,   265,   130,   130,   130,   130,   118,    20,   130,   244,
     174,   244,   244,   115,   936,   937,   938,   939,   940,   941,
     942,   185,   186,   187,   188,   189,   190,   191,   192,     1,
     142,   262,   262,   147,    47,   244,   265,   265,   265,   265,
     265,    13,   265,   265,   265,   265,   265,   159,    20,   265,
     265,   153,   265,   155,  1392,   265,   220,   212,    71,   223,
     265,    74,   265,   175,   265,   262,   265,   265,    81,   181,
     182,   265,   265,   147,   265,    47,   265,   179,   265,    92,
      15,   245,   246,   247,   265,   249,   250,   265,   265,   265,
     265,   255,   265,   265,   265,   259,   265,   262,   265,   201,
     202,   262,   257,   258,   206,   118,    41,   265,   210,    81,
     244,   213,   265,    48,   216,   265,   265,   219,   147,   147,
     244,   244,   234,   225,    59,   130,   130,   244,   147,   130,
     130,     1,   130,   146,   236,   244,   244,   239,   244,   241,
     242,     0,     1,   244,   256,   130,     5,    17,    18,    87,
     244,   253,   244,    88,   244,   168,    26,    16,   147,   261,
     130,    20,   130,   130,   130,   130,    25,   130,   181,   244,
     142,   244,   265,   244,    33,   244,   265,   265,   244,   151,
     152,    40,    52,    53,   119,   120,   121,   244,   147,   244,
      49,   244,   244,   244,   129,    54,    55,   244,   147,   147,
     130,   244,    87,   244,   244,   177,   262,   265,   262,   181,
     147,    81,   244,   147,   147,   265,   265,   265,   156,   265,
     233,    80,   157,   265,   147,   147,    85,   265,   265,   265,
     265,   265,   102,   103,   104,   173,    95,   262,   108,   265,
     262,   265,   112,   178,   257,   265,   262,   265,   118,   147,
     265,   265,   262,   265,   265,   262,   194,   116,   117,     1,
     262,   131,   132,   201,   244,   244,   265,    93,    93,   265,
     265,   156,   210,   265,   265,   145,   130,   265,   265,   138,
     244,   265,   265,   244,   256,   130,   244,   244,    30,    31,
     147,   147,   147,   130,   147,   130,    38,   156,   236,   169,
     238,   239,   262,   147,   244,   147,   176,   262,   243,   194,
     264,   170,   171,   265,   265,   253,   201,   262,   265,   265,
     262,   265,   260,   261,   265,   210,   161,   162,   163,   164,
     165,   166,   167,   262,   193,   262,    78,   265,   262,   198,
     265,    83,    84,   130,   265,   265,   265,   217,    90,    91,
     265,   236,   211,   238,   239,   262,   262,    99,   100,   101,
     262,   262,   262,   222,   130,   262,   262,   226,   253,   195,
     195,   197,   197,   232,   200,   200,   261,   130,   204,   204,
     196,   262,   262,   199,   126,   127,   262,   213,   213,   205,
     262,   207,   218,   218,   210,   262,   262,   262,   214,   215,
     216,   262,   228,   228,   230,   230,   148,   130,   224,   235,
     235,   262,   196,   229,   230,   199,   262,   265,   130,   130,
     130,   205,   147,   207,   240,   130,   210,   130,   130,   262,
     214,   215,   216,   196,   147,   244,   199,   265,   147,   147,
     224,   147,   205,   147,   207,   229,   230,   210,   147,   147,
     130,   214,   215,   216,   147,   147,   240,   147,   147,   262,
     147,   224,   147,   262,   147,   147,   229,   230,   147,   262,
     262,   147,   147,   262,   262,   147,   262,   240,   147,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   147,   262,   262,   130,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   147,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     147,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   244,   262,   147,
     262,   262,   262,   262,   262,   147,   262,   147,   265,   147,
     147,   147,   130,   147,   147,   147,   147,   147,   244,   147,
     147,   262,   147,   147,   147,   265,   262,   262,   262,   266,
     244,   262,   147,   147,   262,   147,   147,   147,   147,   147,
     147,   265,   147,   147,   265,   262,   147,   265,   147,   262,
     147,   262,   262,   637,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   244,   262,   130,   262,   262,   265,   262,   262,   265,
     262,   264,   262,   262,   265,   262,   262,   262,   262,   674,
     262,  1418,   262,   262,   262,   154,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   154,   262,   262,   262,   262,   262,
     154,   262,   147,   262,   154,   154,   154,   262,   154,   147,
     154,   154,   147,   262,   251,   147,   262,    83,   570,  1256,
    1184,  1508,   586,   262,  1458,   267,   267,   267,  1456,   262,
    1451,   267,  1427,  1443,  1441,   555,   262,   529,   603,   262,
     262,  1467,   262,  1305,   262,  1460,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   646,   262,   262,   265,   262,   262,   262,   262,
     262,   262,  1432,   544,   662,   125,   193,   267,  1269,   267,
     262,   267,   267,   267,   265,   262,   265,   265,   262,   265,
     262,   262,   265,   262,   262,   262,   262,  1267,  1262,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   438,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   449
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   269,     0,     1,     5,    16,    20,    25,    33,    40,
      49,    54,    55,    80,    85,    95,   116,   117,   138,   156,
     170,   171,   193,   198,   211,   222,   226,   232,   270,   275,
     283,   289,   305,   319,   325,   331,   340,   354,   378,   403,
     418,   435,   442,   446,   456,   465,   487,   493,   499,   503,
     509,   584,   601,   262,   263,   264,   264,   379,   466,   494,
     332,   264,   504,   264,   419,   488,   404,   264,   326,   355,
     436,   264,   264,   276,   457,   264,   264,   447,   290,     1,
      34,    44,   118,   320,   321,   322,   323,   324,     1,    30,
      31,    38,    78,    83,    84,    90,    91,    99,   100,   101,
     126,   127,   148,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   264,
     264,   264,   264,     1,    79,   500,   501,   502,   264,     1,
       4,     7,     8,    14,    21,    22,    23,    24,    27,    28,
      29,    36,    37,    42,    45,    46,    50,    57,    58,    60,
      61,    62,    63,    70,    76,    77,    86,    89,    98,   105,
     107,   109,   111,   113,   114,   125,   128,   134,   135,   136,
     137,   139,   140,   141,   144,   174,   185,   186,   187,   188,
     189,   190,   191,   192,   220,   223,   245,   246,   247,   249,
     250,   255,   259,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   565,   566,   567,
     570,   574,   578,   579,   580,   581,   582,   583,   264,   264,
     264,     1,   115,   143,   160,   284,   285,   286,   287,   288,
     264,   264,   264,     1,    39,    51,    64,    65,    67,    68,
      69,    94,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,     1,    34,    73,    82,   106,   110,   118,   122,
     123,   212,   257,   258,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   264,   264,     1,
     254,   341,   342,   343,   344,   345,     1,   118,   443,   444,
     445,   264,   264,   262,   265,   265,   265,   263,   321,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   263,   586,     1,    17,    18,    26,    52,
      53,    81,   102,   103,   104,   108,   112,   118,   131,   132,
     145,   169,   176,   217,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,     1,     3,     6,    13,    20,    47,
      71,    74,    81,    92,   118,   146,   168,   181,   233,   257,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   483,   484,   485,   486,     1,    79,   150,
     495,   496,   497,   498,     1,    97,   118,   150,   333,   334,
     335,   336,   337,   265,   263,   501,     1,   118,   150,   505,
     506,   507,   508,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     575,   265,   571,   564,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   263,   511,     1,    13,
      20,    47,    81,   142,   151,   152,   177,   181,   256,   420,
     421,   422,   423,   424,   425,   426,   430,   431,   432,   433,
     434,     1,   150,   256,   489,   490,   491,   492,     1,    71,
      79,    81,   146,   233,   405,   409,   410,   411,   415,   416,
     417,   262,   265,   265,   265,   263,   285,     1,    96,   203,
     327,   328,   329,   330,     1,    20,    47,    81,   118,   142,
     159,   175,   181,   182,   234,   256,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   370,   374,     1,
      49,    96,   150,   437,   438,   439,   440,   441,   265,   265,
     265,   265,   265,   265,   265,   265,   263,   603,   262,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     263,   307,     1,   118,   133,   221,   256,   277,   278,   279,
     280,   281,   282,     1,   118,   252,   458,   459,   460,   461,
     262,   265,   263,   342,   203,   265,   263,   444,     1,   118,
     252,   256,   448,   449,   450,   451,   452,     1,    13,    19,
      75,   118,   183,   184,   291,   292,   293,   294,   295,   296,
     297,   298,   147,   147,   147,   262,   130,   130,   244,   130,
     272,   130,   272,   272,   272,   130,   130,   130,   244,   244,
     244,   262,   262,   265,   265,   265,   265,   265,   400,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   263,   381,   262,   265,   265,   265,   265,   265,   265,
     265,   480,   265,   265,   265,   265,   265,   265,   265,   263,
     468,   265,   265,   263,   496,   262,   265,   265,   265,   263,
     334,   147,   262,   265,   265,   263,   506,   244,   244,   272,
     272,   147,   147,   147,   244,   244,   130,   130,   244,   147,
     130,   244,   244,   244,   272,   244,   130,   130,   272,   130,
     244,   244,   244,   272,   147,   130,   130,   272,   130,   130,
     130,   130,   244,   244,   265,   244,   265,   265,   244,   272,
     272,   244,   244,   147,   244,   244,   248,   244,   248,   244,
     244,   244,   244,   147,   147,   130,   272,   244,   272,   272,
     244,   244,   262,   262,   265,   265,   265,   427,   265,   265,
     265,   265,   265,   265,   263,   421,   265,   265,   263,   490,
     262,   265,   265,   406,   265,   265,   263,   410,   147,   147,
     147,   262,   262,   265,   265,   263,   328,   262,   265,   265,
     375,   265,   265,   265,   371,   265,   265,   367,   265,   263,
     357,   262,   265,   265,   265,   263,   438,   244,   244,   244,
     147,   244,   244,   244,   272,   262,   147,   244,   147,   130,
     130,   147,   147,   147,   130,   147,   147,   262,   262,   265,
     265,   265,   265,   263,   278,   262,   265,   462,   263,   459,
     244,   262,   264,   147,   262,   262,   265,   453,   265,   263,
     449,   262,   265,   265,   299,   265,   265,   265,   263,   292,
     262,   262,   262,   262,   262,   262,   161,   162,   163,   164,
     165,   166,   167,   271,   272,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   130,   130,   272,   130,
     130,   265,   130,   272,   130,   130,   272,   147,   130,   130,
     272,   130,   274,   274,   274,   262,   147,   208,   209,   147,
     147,   244,   147,   147,   265,   147,   147,   130,   147,   147,
     147,   147,   262,   147,   147,   262,   147,   338,   339,   147,
     147,   262,   262,   147,   147,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   196,   199,   205,   207,   210,   214,   215,
     216,   224,   229,   230,   240,   576,   577,   262,    93,   195,
     197,   200,   204,   213,   218,   228,   230,   235,   572,   573,
     196,   199,   205,   207,   210,   214,   215,   216,   224,   229,
     230,   240,   568,   569,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   147,   147,
     244,   265,   147,   130,   147,   147,   147,   147,   262,   147,
     147,   262,   147,   147,   265,   130,   413,   414,   147,   262,
     262,   262,   262,   147,   147,   262,   147,   244,   265,   147,
     147,   147,   265,   147,   244,   265,   147,   262,   147,   147,
     147,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   147,   244,   147,   147,   262,   147,   265,   262,   262,
       1,   118,   227,   252,   346,   347,   348,   349,   350,   262,
     147,   265,   147,   262,   147,   147,   264,   147,   147,   147,
     262,   271,   271,   271,   271,   271,   271,   271,   262,   262,
     262,   262,   262,    66,   149,   401,   402,   262,   262,   262,
     262,   262,   262,   262,   262,   262,    10,    11,    12,   273,
     274,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   262,     9,   231,   481,   482,   262,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   266,   262,   262,   262,
     262,   262,   266,   267,   267,   267,   262,   266,   262,   266,
     262,   262,   262,    15,    41,    48,    59,    88,   119,   120,
     121,   129,   157,   178,   243,   428,   429,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,    32,    64,    72,
     221,   231,   407,   408,   251,   266,   412,   262,   262,   262,
     262,   262,     5,    25,    35,    56,    85,    87,   115,   153,
     155,   179,   201,   202,   206,   210,   213,   216,   219,   225,
     236,   239,   241,   242,   253,   261,   376,   377,   262,   262,
     262,    93,   195,   197,   200,   204,   213,   218,   228,   230,
     235,   372,   373,   262,   262,   196,   199,   205,   207,   210,
     214,   215,   216,   224,   229,   230,   240,   368,   369,   262,
     262,   262,   262,   262,   262,   262,   262,   262,    87,   156,
     194,   201,   210,   236,   238,   239,   253,   261,   463,   464,
     262,   265,   265,   351,   263,   347,   262,    87,   156,   173,
     194,   201,   210,   236,   238,   239,   253,   260,   261,   454,
     455,   262,   262,   262,     1,   158,   172,   180,   300,   301,
     302,   303,   304,   262,   262,   262,   262,   266,   273,   273,
     273,   262,   266,   339,   577,   154,   154,   154,   573,   569,
     262,   266,   262,   266,   130,   414,   262,   267,   267,   267,
     262,   266,   267,   267,   267,   262,   266,   262,   266,   262,
     266,   147,   237,   274,   265,   262,   262,   266,   262,   265,
     265,   265,   263,   301,   402,   482,   429,   408,   154,   154,
     154,   377,   154,   154,   154,   373,   369,   464,   262,   262,
     262,    56,    85,    87,   138,   156,   200,   201,   256,   261,
     352,   353,   455,   147,   147,   147,   262,   262,   266,   262,
     262,   262,   353
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   268,   269,   269,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     271,   271,   272,   272,   272,   272,   272,   272,   272,   272,
     273,   273,   274,   274,   274,   274,   276,   275,   277,   277,
     278,   278,   278,   278,   278,   279,   280,   281,   282,   283,
     284,   284,   285,   285,   285,   285,   286,   287,   288,   290,
     289,   291,   291,   292,   292,   292,   292,   292,   292,   292,
     293,   294,   295,   296,   297,   299,   298,   300,   300,   301,
     301,   301,   301,   302,   303,   304,   305,   306,   306,   307,
     307,   307,   307,   307,   307,   307,   307,   307,   307,   307,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   320,   321,   321,   321,   321,   322,
     323,   324,   326,   325,   327,   327,   328,   328,   328,   329,
     330,   332,   331,   333,   333,   334,   334,   334,   334,   335,
     336,   337,   338,   338,   339,   340,   341,   341,   342,   342,
     342,   343,   345,   344,   346,   346,   347,   347,   347,   347,
     348,   349,   349,   351,   350,   352,   352,   353,   353,   353,
     353,   353,   353,   353,   353,   353,   355,   354,   356,   356,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     367,   366,   368,   368,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   371,   370,   372,
     372,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   375,   374,   376,   376,   377,   377,
     377,   377,   377,   377,   377,   377,   377,   377,   377,   377,
     377,   377,   377,   377,   377,   377,   377,   377,   377,   377,
     377,   377,   377,   377,   377,   379,   378,   380,   380,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   400,   399,   401,   401,   402,
     402,   404,   403,   406,   405,   407,   407,   408,   408,   408,
     408,   408,   409,   409,   410,   410,   410,   410,   410,   410,
     412,   411,   413,   413,   414,   414,   415,   416,   417,   419,
     418,   420,   420,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   422,   423,   424,   425,   427,   426,
     428,   428,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   430,   431,   432,   433,   434,   436,
     435,   437,   437,   438,   438,   438,   438,   439,   440,   441,
     442,   443,   443,   444,   444,   445,   447,   446,   448,   448,
     449,   449,   449,   449,   450,   451,   453,   452,   454,   454,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   457,   456,   458,   458,   459,   459,   459,   460,
     462,   461,   463,   463,   464,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   466,   465,   467,   467,   468,   468,
     468,   468,   468,   468,   468,   468,   468,   468,   468,   468,
     468,   468,   468,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   478,   480,   479,   481,   481,   482,
     482,   483,   484,   485,   486,   488,   487,   489,   489,   490,
     490,   490,   491,   492,   494,   493,   495,   495,   496,   496,
     496,   497,   498,   499,   500,   500,   501,   501,   502,   504,
     503,   505,   505,   506,   506,   506,   507,   508,   509,   510,
     510,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   544,   545,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   564,   563,
     565,   566,   567,   568,   568,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   571,   570,   572,
     572,   573,   573,   573,   573,   573,   573,   573,   573,   573,
     573,   573,   573,   573,   575,   574,   576,   576,   577,   577,
     577,   577,   577,   577,   577,   577,   577,   577,   577,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   585,   586,
     586,   586,   586,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   586,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     602,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     604,   605,   606,   607,   608,   609,   610,   611
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       0,     1,     2,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     2,     3,     3,     3,     0,     6,     2,     1,
       1,     1,     1,     1,     2,     4,     4,     4,     4,     5,
       2,     1,     1,     1,     1,     2,     4,     4,     4,     0,
       6,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     4,     4,     4,     4,     0,     6,     2,     1,     1,
       1,     1,     2,     4,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     5,     2,     1,     1,     1,     1,     2,     4,
       4,     4,     0,     6,     2,     1,     1,     1,     2,     4,
       4,     0,     6,     2,     1,     1,     1,     1,     2,     4,
       4,     4,     3,     1,     1,     5,     2,     1,     1,     1,
       2,     4,     0,     6,     2,     1,     1,     1,     1,     2,
       4,     4,     4,     0,     5,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     6,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     4,     4,     4,     4,     4,     4,     4,     4,
       0,     5,     3,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     3,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     0,     5,     3,     1,     3,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     6,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     0,     5,     3,     1,     1,
       1,     0,     6,     0,     5,     3,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     2,
       0,     5,     3,     1,     1,     3,     4,     4,     4,     0,
       6,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     4,     4,     4,     4,     0,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     0,
       6,     2,     1,     1,     1,     1,     2,     4,     4,     4,
       5,     2,     1,     1,     1,     4,     0,     6,     2,     1,
       1,     1,     1,     2,     4,     4,     0,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     1,     1,     1,     2,     4,
       0,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     6,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     0,     5,     3,     1,     1,
       1,     4,     4,     4,     4,     0,     6,     2,     1,     1,
       1,     1,     4,     4,     0,     6,     2,     1,     1,     1,
       1,     4,     4,     5,     2,     1,     1,     1,     4,     0,
       6,     2,     1,     1,     1,     1,     4,     4,     5,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     0,     5,
       4,     4,     4,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     3,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     0,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     4,     4,     4,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     5,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     4,     4,     4,     4,     4,     4,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 30:
#line 455 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3122 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 457 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number);
		}
#line 3130 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 461 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number);
		}
#line 3138 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 465 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 + (yyvsp[0].number);
		}
#line 3146 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 469 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 + (yyvsp[0].number);
		}
#line 3154 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 473 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 + (yyvsp[0].number);
		}
#line 3162 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 477 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 + (yyvsp[0].number);
		}
#line 3170 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 481 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 * 4 + (yyvsp[0].number);
                }
#line 3178 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 485 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 365 + (yyvsp[0].number);
                }
#line 3186 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 490 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3192 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 491 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number); }
#line 3198 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 492 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 3204 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 493 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 + (yyvsp[0].number); }
#line 3210 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 494 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 * 1024 + (yyvsp[0].number); }
#line 3216 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 501 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.ptr.alias = MyMalloc(sizeof(struct alias_entry));
}
#line 3227 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 507 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  dlinkAdd(block_state.ptr.alias, &block_state.ptr.alias->node, &alias_items);
  alias_add(block_state.ptr.alias);
}
#line 3239 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 519 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  struct alias_name *nm = MyMalloc(sizeof(struct alias_name));

  strlcpy(nm->name, yylval.string, sizeof(nm->name));
  nm->parent = block_state.ptr.alias;

  dlinkAdd(nm, &nm->node, &block_state.ptr.alias->names);
}
#line 3255 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 532 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->user, yylval.string, sizeof(block_state.ptr.alias->user));
}
#line 3264 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 538 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->server, yylval.string, sizeof(block_state.ptr.alias->server));
}
#line 3273 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 544 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.ptr.alias->flags |= CONF_FLAGS_OPER_ONLY;
  }
}
#line 3285 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 562 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_module(libio_basename(yylval.string));
}
#line 3294 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 568 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_script(yylval.string);
}
#line 3303 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 574 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    mod_add_path(yylval.string);
}
#line 3312 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 581 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.ssl = sslprofile_create();
}
#line 3323 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 588 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  dlink_node *ptr;

  if (conf_parser_ctx.pass != 1)
    break;

  DLINK_FOREACH(ptr, profile->identities.head)
  {
    struct sslprofile_identity *id = ptr->data;

    if (profile->dh)
      SSL_CTX_set_tmp_dh(id->server_ctx, profile->dh);

#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
    if (profile->curve)
      SSL_CTX_set_tmp_ecdh(id->server_ctx, profile->curve);
#endif

    if (!EmptyString(profile->cipher_list))
    {
      SSL_CTX_set_cipher_list(id->server_ctx, profile->cipher_list);

      SSL_CTX_set_cipher_list(id->client_ctx, profile->cipher_list);
    }

    if (!EmptyString(profile->ca_file))
    {
      if (!SSL_CTX_load_verify_locations(id->server_ctx, profile->ca_file, NULL))
      {
        const char *s = ERR_lib_error_string(ERR_get_error());

        ilog(LOG_TYPE_IRCD, "Could not load verify location %s -- %s", profile->ca_file, s);
      }
    }
  }

  dlinkAddTail(block_state.ptr.ssl, &block_state.ptr.ssl->node, &sslprofile_items);
  block_state.ptr.ssl = NULL;
}
#line 3368 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 636 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->name, yylval.string, sizeof(entry->name));
}
#line 3379 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 644 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
  {
    BIO *file = BIO_new_file(yylval.string, "r");

    if (file)
    {
      DH *dh = PEM_read_bio_DHparams(file, NULL, NULL, NULL);

      BIO_free(file);

      if (dh)
      {
        if (DH_size(dh) < 256)
        {
          conf_error_report("Ignoring sslprofile::dh_param_file -- need at least a 2048 bit DH prime size");
          DH_free(dh);
        }
        else
        {
          entry->dh = dh;
        }
      }
    }
    else
      conf_error_report("Ignoring sslprofile::dh_param_file -- could not open/read Diffie-Hellman parameter file");
  }
}
#line 3414 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 676 "conf_parser.y" /* yacc.c:1646  */
    {
#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
  struct sslprofile *entry = block_state.ptr.ssl;
  int nid = 0;
  EC_KEY *key = NULL;

  if (conf_parser_ctx.pass == 1)
  {
    if ((nid = OBJ_sn2nid(yylval.string)) == 0)
    {
        conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- unknown curve name");
        break;
    }

    if ((key = EC_KEY_new_by_curve_name(nid)) == NULL)
    {
      conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- could not create curve");
      break;
    }

    entry->curve = key;
  }
#endif
}
#line 3443 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 702 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->cipher_list, yylval.string, sizeof(entry->cipher_list));
}
#line 3454 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 710 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->ca_file, yylval.string, sizeof(entry->ca_file));
}
#line 3465 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 718 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.identity = sslprofile_identity_create(block_state.ptr.ssl);
}
#line 3476 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 725 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  struct sslprofile_identity *id = block_state.ptr.identity;

  if (conf_parser_ctx.pass != 1)
    break;

  if (id == NULL)
    break;

  dlinkAddTail(id, &id->node, &profile->identities);
  block_state.ptr.identity = NULL;
}
#line 3494 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 745 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  char *str;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  str = xstrdup(yylval.string);
  dlinkAdd(str, make_dlink_node(), &entry->server_names);
}
#line 3512 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 760 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  BIO *file = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  if (entry->rsa_private_key)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;
  }

  if (entry->rsa_private_key_file)
  {
    MyFree(entry->rsa_private_key_file);
    entry->rsa_private_key_file = NULL;
  }

  entry->rsa_private_key_file = xstrdup(yylval.string);

  if ((file = BIO_new_file(yylval.string, "r")) == NULL)
  {
    conf_error_report("File open failed, ignoring");
    break;
  }

  entry->rsa_private_key = PEM_read_bio_RSAPrivateKey(file, NULL, 0, NULL);

  BIO_set_close(file, BIO_CLOSE);
  BIO_free(file);

  if (entry->rsa_private_key == NULL)
  {
    conf_error_report("Couldn't extract key, ignoring");
    break;
  }

  if (!RSA_check_key(entry->rsa_private_key))
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Invalid key, ignoring");
    break;
  }

  if (RSA_size(entry->rsa_private_key) < 256)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Ignoring sslprofile::identity::rsa_private_key_file -- need at least a 2048 bit key size");
  }
}
#line 3575 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 820 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;

  if (conf_parser_ctx.pass == 1 && entry)
  {
    if (!entry->rsa_private_key_file)
    {
      conf_error_report("No rsa_private_key_file specified, SSL disabled");
      break;
    }

    if (SSL_CTX_use_certificate_chain_file(entry->server_ctx, yylval.string) <= 0 ||
        SSL_CTX_use_certificate_chain_file(entry->client_ctx, yylval.string) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not open/read certificate file");
      break;
    }

    if (SSL_CTX_use_PrivateKey_file(entry->server_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0 ||
        SSL_CTX_use_PrivateKey_file(entry->client_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }

    if (!SSL_CTX_check_private_key(entry->server_ctx) ||
        !SSL_CTX_check_private_key(entry->client_ctx))
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }
  }
}
#line 3618 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 874 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.name)
  {
    if (valid_servname(yylval.string))
      ServerInfo.name = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::name -- invalid name. Aborting.");
      exit(0);
    }
  }
}
#line 3636 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 889 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.sid)
  {
    if (valid_sid(yylval.string))
      ServerInfo.sid = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::sid -- invalid SID. Aborting.");
      exit(0);
    }
  }
}
#line 3654 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 904 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ServerInfo.description);
    ServerInfo.description = xstrdup(yylval.string);
  }
}
#line 3666 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 913 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    char *p;

    if ((p = strchr(yylval.string, ' ')) != NULL)
      *p = '\0';

    MyFree(ServerInfo.network_name);
    ServerInfo.network_name = xstrdup(yylval.string);
  }
}
#line 3683 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 927 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(ServerInfo.network_desc);
  ServerInfo.network_desc = xstrdup(yylval.string);
}
#line 3695 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 936 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip.ss.ss_family = res->ai_family;
      ServerInfo.ip.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv4_vhost = 1;
    }
  }
}
#line 3726 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 964 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost6(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip6, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip6.ss.ss_family = res->ai_family;
      ServerInfo.ip6.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv6_vhost = 1;
    }
  }
#endif
}
#line 3759 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 994 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < MAXCLIENTS_MIN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too low, setting to %d", MAXCLIENTS_MIN);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MIN;
  }
  else if ((yyvsp[-1].number) > MAXCLIENTS_MAX)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too high, setting to %d", MAXCLIENTS_MAX);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MAX;
  }
  else
    ServerInfo.max_clients = (yyvsp[-1].number);
}
#line 3787 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1019 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 9)
  {
    conf_error_report("max_nick_length too low, setting to 9");
    ServerInfo.max_nick_length = 9;
  }
  else if ((yyvsp[-1].number) > NICKLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_nick_length too high, setting to %d", NICKLEN);
    conf_error_report(buf);
    ServerInfo.max_nick_length = NICKLEN;
  }
  else
    ServerInfo.max_nick_length = (yyvsp[-1].number);
}
#line 3812 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1041 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 80)
  {
    conf_error_report("max_topic_length too low, setting to 80");
    ServerInfo.max_topic_length = 80;
  }
  else if ((yyvsp[-1].number) > TOPICLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_topic_length too high, setting to %d", TOPICLEN);
    conf_error_report(buf);
    ServerInfo.max_topic_length = TOPICLEN;
  }
  else
    ServerInfo.max_topic_length = (yyvsp[-1].number);
}
#line 3837 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1063 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ServerInfo.hub = yylval.number;
}
#line 3846 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1078 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.name);
  AdminInfo.name = xstrdup(yylval.string);
}
#line 3858 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1087 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.email);
  AdminInfo.email = xstrdup(yylval.string);
}
#line 3870 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1096 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.description);
  AdminInfo.description = xstrdup(yylval.string);
}
#line 3882 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1108 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 3891 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1112 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.file.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
    motd_add(ptr->data, block_state.file.buf);
}
#line 3908 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1129 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 3917 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1135 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 3926 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1145 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    reset_block_state();
    block_state.ptr.dnsbl = MyMalloc(sizeof(struct dnsbl_entry));
  }
}
#line 3938 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1153 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_entry *dnsbl = block_state.ptr.dnsbl;

    if (dlink_list_length(&dnsbl->matches) == 0)
    {
      /* Add a default match */
      struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));
      parse_netmask("127.0.0.0/8", &match->ip, &match->bits);
      dlinkAdd(match, &match->node, &dnsbl->matches);
    }

    dlinkAdd(dnsbl, &dnsbl->node, &dnsbl_items);
  }
}
#line 3959 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1175 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->name, yylval.string, sizeof(block_state.ptr.dnsbl->name));
}
#line 3968 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1181 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->reason, yylval.string, sizeof(block_state.ptr.dnsbl->reason));
}
#line 3977 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1189 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));

    if (parse_netmask((yyvsp[0].string), &match->ip, &match->bits) == HM_IPV4)
    {
      dlinkAdd(match, &match->node, &block_state.ptr.dnsbl->matches);
    }
    else
    {
      char buf[IRCD_BUFSIZE];

      snprintf(buf, sizeof(buf), "dnsbl match %s not an IPv4 mask, ignored", (yyvsp[0].string));
      conf_error_report(buf);

      MyFree(match);
    }
  }
}
#line 4002 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1220 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigLoggingEntry.use_logging = yylval.number;
}
#line 4011 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1226 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 4020 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1230 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (block_state.type.value && block_state.file.buf[0])
    log_set_file(block_state.type.value, block_state.size.value,
                 block_state.file.buf);
}
#line 4033 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1246 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4044 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1254 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = (yyvsp[-1].number);
}
#line 4052 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1257 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = 0;
}
#line 4060 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1262 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = 0;
}
#line 4069 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1269 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_USER;
}
#line 4078 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1273 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_OPER;
}
#line 4087 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1277 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_GLINE;
}
#line 4096 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1281 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_XLINE;
}
#line 4105 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1285 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_RESV;
}
#line 4114 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1289 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DLINE;
}
#line 4123 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1293 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KLINE;
}
#line 4132 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1297 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KILL;
}
#line 4141 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1301 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DEBUG;
}
#line 4150 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1311 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
}
#line 4162 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1318 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;
  if (!block_state.file.buf[0] &&
      !block_state.rpass.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    conf         = conf_make(CONF_OPER);
    conf->name   = xstrdup(block_state.name.buf);
    conf->user   = xstrdup(block_state.user.buf);
    conf->host   = xstrdup(block_state.host.buf);

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);

    conf->flags = block_state.flags.value;
    conf->modes = block_state.modes.value;
    conf->snomask.local = block_state.snomask_local.value;
    conf->snomask.remote = block_state.snomask_remote.value;
    conf->port  = block_state.port.value;
    conf->htype = parse_netmask(conf->host, &conf->addr, &conf->bits);

    conf_add_class_to_conf(conf, block_state.class.buf);

    if (block_state.file.buf[0])
    {
      BIO *file = NULL;
      RSA *pkey = NULL;

      if ((file = BIO_new_file(block_state.file.buf, "r")) == NULL)
      {
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- file doesn't exist");
        break;
      }

      if ((pkey = PEM_read_bio_RSA_PUBKEY(file, NULL, 0, NULL)) == NULL)
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- Key invalid; check key syntax");
      else
      {
        if (RSA_size(pkey) > 128)
          ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- key size must be 1024 or below");
        else
          conf->rsa_public_key = pkey;
      }

      BIO_set_close(file, BIO_CLOSE);
      BIO_free(file);
    }
  }
}
#line 4239 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1399 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 4248 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1405 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 4257 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1411 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 4266 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1417 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
  else
    block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
}
#line 4280 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1428 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4289 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1434 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 4298 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1440 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_SSL;
  else
    block_state.flags.value &= ~CONF_FLAGS_SSL;
}
#line 4312 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1451 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4321 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1457 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value = 0;
}
#line 4330 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1465 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_NOCTCP;
}
#line 4339 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1470 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_DEAF;
}
#line 4348 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1475 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_HIDECHANNELS;
}
#line 4357 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1480 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_OPERWALL;
}
#line 4366 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1485 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SERVNOTICE;
}
#line 4375 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1490 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_INVISIBLE;
}
#line 4384 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1495 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_WALLOP;
}
#line 4393 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1500 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SOFTCALLERID;
}
#line 4402 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1505 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_CALLERID;
}
#line 4411 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1510 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_LOCOPS;
}
#line 4420 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1515 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_REGONLY;
}
#line 4429 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1520 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SPY;
}
#line 4438 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1526 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value = block_state.snomask_remote.value = 0;
}
#line 4447 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1534 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_bots.flag;
}
#line 4456 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1539 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_bots.flag;
}
#line 4465 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1544 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_cconn.flag;
}
#line 4474 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1549 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_cconn.flag;
}
#line 4483 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1554 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_debug.flag;
}
#line 4492 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1559 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_full.flag;
}
#line 4501 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1564 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_skill.flag;
}
#line 4510 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1569 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_nchange.flag;
}
#line 4519 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1574 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_rej.flag;
}
#line 4528 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1579 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_unauth.flag;
}
#line 4537 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1584 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_spy.flag;
}
#line 4546 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1589 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_link.flag;
}
#line 4555 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1594 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
     block_state.snomask_local.value |= sno_link.flag;
}
#line 4564 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1600 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = 0;
}
#line 4573 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1607 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL_REMOTE;
}
#line 4582 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1611 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_FARCONNECT;
}
#line 4591 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1615 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_N;
}
#line 4600 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1619 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL;
}
#line 4609 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1623 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT_REMOTE;
}
#line 4618 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1627 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT;
}
#line 4627 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1631 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT_REMOTE;
}
#line 4636 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1635 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT;
}
#line 4645 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1639 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_K;
}
#line 4654 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1643 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNKLINE;
}
#line 4663 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1647 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DLINE;
}
#line 4672 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1651 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNDLINE;
}
#line 4681 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1655 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_XLINE;
}
#line 4690 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1659 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNXLINE;
}
#line 4699 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1663 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLINE;
}
#line 4708 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1667 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DIE;
}
#line 4717 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1671 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_RESTART;
}
#line 4726 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1675 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REHASH;
}
#line 4735 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1679 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_ADMIN;
}
#line 4744 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1683 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_OPERWALL;
}
#line 4753 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1687 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLOBOPS;
}
#line 4762 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1691 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLOPS;
}
#line 4771 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1695 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLUSERS;
}
#line 4780 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1699 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_LOCOPS;
}
#line 4789 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1703 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REMOTEBAN;
}
#line 4798 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1707 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SET;
}
#line 4807 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1711 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_MODULE;
}
#line 4816 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1721 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();

  block_state.ping_freq.value = DEFAULT_PINGFREQUENCY;
  block_state.con_freq.value  = DEFAULT_CONNECTFREQUENCY;
  block_state.max_total.value = MAXIMUM_LINKS_DEFAULT;
  block_state.max_sendq.value = DEFAULT_SENDQ;
  block_state.max_recvq.value = DEFAULT_RECVQ;
}
#line 4833 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1733 "conf_parser.y" /* yacc.c:1646  */
    {
  struct ClassItem *class = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (!block_state.class.buf[0])
    break;

  if (!(class = class_find(block_state.class.buf, 0)))
    class = class_make();

  class->active = 1;
  MyFree(class->name);
  class->name = xstrdup(block_state.class.buf);
  class->ping_freq = block_state.ping_freq.value;
  class->max_perip = block_state.max_perip.value;
  class->con_freq = block_state.con_freq.value;
  class->max_total = block_state.max_total.value;
  class->max_global = block_state.max_global.value;
  class->max_local = block_state.max_local.value;
  class->soft_sendq = block_state.soft_sendq.value;
  class->flood_burst = block_state.flood_burst.value;
  class->flood_limit = block_state.flood_limit.value;
  class->max_sendq = block_state.max_sendq.value;
  class->max_recvq = block_state.max_recvq.value;

  if (block_state.min_idle.value > block_state.max_idle.value)
  {
    block_state.min_idle.value = 0;
    block_state.max_idle.value = 0;
    block_state.flags.value &= ~CLASS_FLAGS_FAKE_IDLE;
  }

  class->flags = block_state.flags.value;
  class->min_idle = block_state.min_idle.value;
  class->max_idle = block_state.max_idle.value;

  rebuild_cidr_list(class);

  class->cidr_bitlen_ipv4 = block_state.cidr_bitlen_ipv4.value;
  class->cidr_bitlen_ipv6 = block_state.cidr_bitlen_ipv6.value;
  class->number_per_cidr = block_state.number_per_cidr.value;
}
#line 4882 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1795 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4891 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1801 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ping_freq.value = (yyvsp[-1].number);
}
#line 4900 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1807 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_perip.value = (yyvsp[-1].number);
}
#line 4909 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1813 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.con_freq.value = (yyvsp[-1].number);
}
#line 4918 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1819 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_total.value = (yyvsp[-1].number);
}
#line 4927 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1825 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_global.value = (yyvsp[-1].number);
}
#line 4936 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1831 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_local.value = (yyvsp[-1].number);
}
#line 4945 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1837 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.soft_sendq.value = (yyvsp[-1].number);
}
#line 4954 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1843 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_burst.value = (yyvsp[-1].number);
}
#line 4963 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1849 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_limit.value = (yyvsp[-1].number);
}
#line 4972 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1855 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_sendq.value = (yyvsp[-1].number);
}
#line 4981 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1861 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    if ((yyvsp[-1].number) >= CLIENT_FLOOD_MIN && (yyvsp[-1].number) <= CLIENT_FLOOD_MAX)
      block_state.max_recvq.value = (yyvsp[-1].number);
}
#line 4991 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1868 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv4.value = (yyvsp[-1].number) > 32 ? 32 : (yyvsp[-1].number);
}
#line 5000 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1874 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv6.value = (yyvsp[-1].number) > 128 ? 128 : (yyvsp[-1].number);
}
#line 5009 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1880 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.number_per_cidr.value = (yyvsp[-1].number);
}
#line 5018 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1886 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.min_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5030 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1895 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.max_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5042 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1904 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value &= CLASS_FLAGS_FAKE_IDLE;
}
#line 5051 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1911 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_RANDOM_IDLE;
}
#line 5060 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1915 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_HIDE_IDLE_FROM_OPERS;
}
#line 5069 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1925 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5078 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1931 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5087 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1938 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_SSL;
}
#line 5096 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1942 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HIDDEN;
}
#line 5105 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1946 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
   block_state.flags.value |= LISTENER_SERVER;
}
#line 5114 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1950 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HTTP;
}
#line 5123 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1954 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_DEFER;
}
#line 5132 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1963 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5141 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1971 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    add_listener((yyvsp[0].number), block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5165 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1990 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    int i;
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    for (i = (yyvsp[-2].number); i <= (yyvsp[0].number); ++i)
      add_listener(i, block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5191 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2013 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5200 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2019 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5209 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2025 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 5218 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2034 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5227 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2038 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    if (EmptyString(block_state.host.buf))
      continue;

    conf        = conf_make(CONF_CLIENT);
    conf->user  = xstrdup(block_state.user.buf);
    conf->host  = xstrdup(block_state.host.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);
    if (block_state.name.buf[0])
      conf->name = xstrdup(block_state.name.buf);

    conf->flags = block_state.flags.value;
    conf->port  = block_state.port.value;

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.ca.buf[0])
    {
      int ret;

      conf->x509_store = X509_STORE_new();
      ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
      if (ret != 1)
      {
        X509_STORE_free(conf->x509_store);
        conf->x509_store = NULL;

        ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring auth block", block_state.ca.buf);
        conf_free(conf);
        continue;
      }
    }

    conf_add_class_to_conf(conf, block_state.class.buf);
    add_conf_by_address(CONF_CLIENT, conf);
  }
}
#line 5291 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2105 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5300 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2111 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5309 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2117 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 5318 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2123 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 5332 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2134 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value &= (CONF_FLAGS_ENCRYPTED | CONF_FLAGS_SPOOF_IP);
}
#line 5341 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2141 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SPOOF_NOTICE;
}
#line 5350 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2145 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NOLIMIT;
}
#line 5359 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2149 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTKLINE;
}
#line 5368 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2153 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTDNSBL;
}
#line 5377 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2157 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_IDENTD;
}
#line 5386 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2161 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_CAN_FLOOD;
}
#line 5395 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2165 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NO_TILDE;
}
#line 5404 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2169 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTGLINE;
}
#line 5413 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2173 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTRESV;
}
#line 5422 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2177 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_WEBIRC;
}
#line 5431 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2181 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_ACCOUNT;
}
#line 5440 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2185 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_PASSWORD;
}
#line 5449 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2191 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (strlen(yylval.string) <= HOSTLEN && valid_hostname(yylval.string))
  {
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
    block_state.flags.value |= CONF_FLAGS_SPOOF_IP;
  }
  else
    ilog(LOG_TYPE_IRCD, "Spoof either is too long or contains invalid characters. Ignoring it.");
}
#line 5466 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2205 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
  block_state.flags.value |= CONF_FLAGS_REDIR;
}
#line 5478 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2214 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.flags.value |= CONF_FLAGS_REDIR;
  block_state.port.value = (yyvsp[-1].number);
}
#line 5490 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2223 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 5501 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2231 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 5512 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2243 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  strlcpy(block_state.rpass.buf, CONF_NOREASON, sizeof(block_state.rpass.buf));
}
#line 5524 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2250 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  create_resv(block_state.name.buf, block_state.rpass.buf, &block_state.mask.list);
}
#line 5535 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2261 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5544 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2267 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5553 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2273 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5562 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2288 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (valid_servname(yylval.string))
  {
    struct MaskItem *conf = conf_make(CONF_SERVICE);
    conf->name = xstrdup(yylval.string);
  }
}
#line 5577 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2303 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  strlcpy(block_state.user.buf, "*", sizeof(block_state.user.buf));
  strlcpy(block_state.host.buf, "*", sizeof(block_state.host.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5593 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2314 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_ULINE);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);
}
#line 5610 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2331 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5619 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2337 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 5641 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2356 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5650 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2363 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5659 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2367 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5668 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2371 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5677 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2375 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5686 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2379 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5695 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2383 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5704 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2387 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5713 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2391 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5722 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2395 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 5731 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2399 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_SESSION;
}
#line 5740 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2403 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_WLINE;
}
#line 5749 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2407 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 5758 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2416 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5772 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2425 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_CLUSTER);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
}
#line 5787 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2440 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5796 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2446 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5805 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2453 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5814 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2457 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5823 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2461 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5832 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2465 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5841 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2469 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5850 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2473 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5859 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2477 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5868 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2481 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5877 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2485 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 5886 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2489 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 5895 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2498 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.aftype.value = AF_INET;
  block_state.port.value = PORTNUM;
}
#line 5909 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2507 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;
  struct addrinfo hints, *res;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0] ||
      !block_state.host.buf[0])
    break;

  if (!block_state.rpass.buf[0] ||
      !block_state.spass.buf[0])
    break;

  if (has_wildcards(block_state.name.buf))
    break;

  conf = conf_make(CONF_SERVER);
  conf->port = block_state.port.value;
  conf->flags = block_state.flags.value;
  conf->aftype = block_state.aftype.value;
  conf->host = xstrdup(block_state.host.buf);
  conf->name = xstrdup(block_state.name.buf);
  conf->passwd = xstrdup(block_state.rpass.buf);
  conf->spasswd = xstrdup(block_state.spass.buf);

  if (block_state.cert.buf[0])
    conf->certfp = xstrdup(block_state.cert.buf);

  dlinkMoveList(&block_state.leaf.list, &conf->leaf_list);
  dlinkMoveList(&block_state.hub.list, &conf->hub_list);

  if (block_state.bind.buf[0])
  {
    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(block_state.bind.buf, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", block_state.bind.buf);
    else
    {
      assert(res != NULL);

      memcpy(&conf->bind, res->ai_addr, res->ai_addrlen);
      conf->bind.ss.ss_family = res->ai_family;
      conf->bind.ss_len = res->ai_addrlen;
      freeaddrinfo(res);
    }
  }

  if (block_state.ca.buf[0])
  {
    int ret;

    conf->x509_store = X509_STORE_new();
    ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
    if (ret != 1)
    {
      X509_STORE_free(conf->x509_store);
      conf->x509_store = NULL;

      ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring connect block", block_state.ca.buf);
      conf_free(conf);
      break;
    }
  }

  conf->ssl_profile = xstrdup(block_state.profile.buf);

  conf_add_class_to_conf(conf, block_state.class.buf);
  lookup_confhost(conf);
}
#line 5990 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2594 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5999 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2600 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.host.buf, yylval.string, sizeof(block_state.host.buf));
}
#line 6008 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2606 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.bind.buf, yylval.string, sizeof(block_state.bind.buf));
}
#line 6017 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2612 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.spass.buf, yylval.string, sizeof(block_state.spass.buf));
}
#line 6033 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2625 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6049 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2638 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 6058 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2644 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 6067 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2650 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 6076 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2656 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = (yyvsp[-1].number);
}
#line 6085 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2662 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET;
}
#line 6094 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2666 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET6;
#endif
}
#line 6105 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2674 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value &= CONF_FLAGS_ENCRYPTED;
}
#line 6113 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2680 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_ALLOW_AUTO_CONN;
}
#line 6122 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2684 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SSL;
}
#line 6131 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2690 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 6145 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2701 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.hub.list);
}
#line 6154 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2707 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.leaf.list);
}
#line 6163 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2713 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 6172 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2723 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6181 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2727 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.user.buf[0] ||
      !block_state.host.buf[0])
    break;

  conf = conf_make(CONF_KLINE);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
  add_conf_by_address(CONF_KLINE, conf);
}
#line 6206 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2752 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 6229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2772 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6238 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2781 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6247 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2785 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.addr.buf[0])
    break;

  if (parse_netmask(block_state.addr.buf, NULL, NULL) != HM_HOST)
  {
    conf = conf_make(CONF_DLINE);
    conf->host = xstrdup(block_state.addr.buf);

    if (block_state.rpass.buf[0])
      conf->reason = xstrdup(block_state.rpass.buf);
    else
      conf->reason = xstrdup(CONF_NOREASON);
    add_conf_by_address(CONF_DLINE, conf);
  }
}
#line 6273 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2811 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 6282 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2817 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6291 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2831 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.string[0] && parse_netmask(yylval.string, NULL, NULL) != HM_HOST)
    {
      struct MaskItem *conf = conf_make(CONF_EXEMPT);
      conf->host = xstrdup(yylval.string);

      add_conf_by_address(CONF_EXEMPT, conf);
    }
  }
}
#line 6308 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2848 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6317 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2852 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;

  conf = conf_make(CONF_XLINE);
  conf->name = xstrdup(block_state.name.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
}
#line 6339 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2874 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6348 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2880 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6357 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2928 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_watch = (yyvsp[-1].number);
}
#line 6365 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2933 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.cycle_on_host_change = yylval.number;
}
#line 6374 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2939 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key1);
    ConfigFileEntry.cloak_key1 = xstrdup(yylval.string);
  }
}
#line 6386 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2948 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key2);
    ConfigFileEntry.cloak_key2 = xstrdup(yylval.string);
  }
}
#line 6398 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2957 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key3);
    ConfigFileEntry.cloak_key3 = xstrdup(yylval.string);
  }
}
#line 6410 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2966 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.cloak_whois_actually = yylval.number;
}
#line 6419 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2972 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.account_whois = yylval.number;
}
#line 6428 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2978 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.glines = yylval.number;
}
#line 6437 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2984 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_time = (yyvsp[-1].number);
}
#line 6446 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2990 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_request_time = (yyvsp[-1].number);
}
#line 6455 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2996 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr = (yyvsp[-1].number);
}
#line 6463 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 606:
#line 3001 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr6 = (yyvsp[-1].number);
}
#line 6471 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 607:
#line 3006 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.kline_reason);
    ConfigFileEntry.kline_reason = xstrdup(yylval.string);
  }
}
#line 6483 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 608:
#line 3015 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.tkline_expire_notices = yylval.number;
}
#line 6491 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 609:
#line 3020 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.kill_chase_time_limit = (yyvsp[-1].number);
}
#line 6499 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 610:
#line 3025 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.hide_spoof_ips = yylval.number;
}
#line 6507 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 611:
#line 3030 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ignore_bogus_ts = yylval.number;
}
#line 6515 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 612:
#line 3035 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.failed_oper_notice = yylval.number;
}
#line 6523 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 613:
#line 3040 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_nick_flood = yylval.number;
}
#line 6531 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 614:
#line 3045 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_time = (yyvsp[-1].number);
}
#line 6539 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 615:
#line 3050 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_changes = (yyvsp[-1].number);
}
#line 6547 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 616:
#line 3055 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_accept = (yyvsp[-1].number);
}
#line 6555 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 617:
#line 3060 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_spam_exit_message_time = (yyvsp[-1].number);
}
#line 6563 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 618:
#line 3065 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ts_warn_delta = (yyvsp[-1].number);
}
#line 6571 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 619:
#line 3070 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.ts_max_delta = (yyvsp[-1].number);
}
#line 6580 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 620:
#line 3076 "conf_parser.y" /* yacc.c:1646  */
    {
  if (((yyvsp[-1].number) > 0) && conf_parser_ctx.pass == 1)
  {
    ilog(LOG_TYPE_IRCD, "You haven't read your config file properly.");
    ilog(LOG_TYPE_IRCD, "There is a line in the example conf that will kill your server if not removed.");
    ilog(LOG_TYPE_IRCD, "Consider actually reading/editing the conf file, and removing this line.");
    exit(0);
  }
}
#line 6594 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 621:
#line 3087 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.invisible_on_connect = yylval.number;
}
#line 6602 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 622:
#line 3092 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.warn_no_nline = yylval.number;
}
#line 6610 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 623:
#line 3097 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_e_disabled = yylval.number;
}
#line 6618 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 624:
#line 3102 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_o_oper_only = yylval.number;
}
#line 6626 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 625:
#line 3107 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_P_oper_only = yylval.number;
}
#line 6634 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 626:
#line 3112 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_u_oper_only = yylval.number;
}
#line 6642 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 627:
#line 3117 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 2 * yylval.number;
}
#line 6650 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 628:
#line 3120 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 1;
}
#line 6658 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 629:
#line 3125 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 2 * yylval.number;
}
#line 6666 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 630:
#line 3128 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 1;
}
#line 6674 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 631:
#line 3133 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_m_oper_only = yylval.number;
}
#line 6682 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 632:
#line 3138 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait = (yyvsp[-1].number);
}
#line 6690 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 633:
#line 3143 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.caller_id_wait = (yyvsp[-1].number);
}
#line 6698 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 634:
#line 3148 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.opers_bypass_callerid = yylval.number;
}
#line 6706 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 635:
#line 3153 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait_simple = (yyvsp[-1].number);
}
#line 6714 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 636:
#line 3158 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.short_motd = yylval.number;
}
#line 6722 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 637:
#line 3163 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.no_oper_flood = yylval.number;
}
#line 6730 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 638:
#line 3168 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_pass_resv = yylval.number;
}
#line 6738 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 639:
#line 3173 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.dots_in_ident = (yyvsp[-1].number);
}
#line 6746 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 640:
#line 3178 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_targets = (yyvsp[-1].number);
}
#line 6754 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 641:
#line 3183 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && valid_servname(yylval.string))
  {
    MyFree(ConfigFileEntry.service_name);
    ConfigFileEntry.service_name = xstrdup(yylval.string);
  }
}
#line 6766 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 642:
#line 3192 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.sasl_name);
    ConfigFileEntry.sasl_name = xstrdup(yylval.string);
  }
}
#line 6778 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 643:
#line 3201 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ping_cookie = yylval.number;
}
#line 6786 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 644:
#line 3206 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.nick_collide_realhost = yylval.number;
}
#line 6794 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 645:
#line 3211 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.disable_auth = yylval.number;
}
#line 6802 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 646:
#line 3216 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_num = yylval.number;
}
#line 6810 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 647:
#line 3221 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_time = (yyvsp[-1].number);
}
#line 6818 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 648:
#line 3226 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes = 0;
}
#line 6826 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 650:
#line 3231 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_extbans = yylval.number;
}
#line 6834 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 651:
#line 3236 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_forwarding = yylval.number;
}
#line 6842 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 652:
#line 3241 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if ((ConfigFileEntry.message_digest_algorithm = EVP_get_digestbyname(yylval.string)) == NULL)
    {
      ConfigFileEntry.message_digest_algorithm = EVP_sha1();
      conf_error_report("Ignoring general::ssl_message_digest_algorithm -- unknown message digest algorithm");
    }
  }
}
#line 6857 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 655:
#line 3254 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_NOCTCP;
}
#line 6865 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 656:
#line 3258 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_DEAF;
}
#line 6873 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 657:
#line 3262 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_HIDECHANNELS;
}
#line 6881 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 658:
#line 3266 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_OPERWALL;
}
#line 6889 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 659:
#line 3270 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SERVNOTICE;
}
#line 6897 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 660:
#line 3274 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_INVISIBLE;
}
#line 6905 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 661:
#line 3278 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_WALLOP;
}
#line 6913 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 662:
#line 3282 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SOFTCALLERID;
}
#line 6921 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 663:
#line 3286 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_CALLERID;
}
#line 6929 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 664:
#line 3290 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_LOCOPS;
}
#line 6937 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 665:
#line 3294 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_REGONLY;
}
#line 6945 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 666:
#line 3298 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SPY;
}
#line 6953 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 667:
#line 3303 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local = ConfigFileEntry.oper_snomasks.remote = 0;
}
#line 6961 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 671:
#line 3310 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_bots.flag;
}
#line 6969 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 672:
#line 3314 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_bots.flag;
}
#line 6977 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 673:
#line 3318 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_cconn.flag;
}
#line 6985 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 674:
#line 3322 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_cconn.flag;
}
#line 6993 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 675:
#line 3326 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_debug.flag;
}
#line 7001 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 676:
#line 3330 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_nchange.flag;
}
#line 7009 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 677:
#line 3334 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_full.flag;
}
#line 7017 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 678:
#line 3338 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_skill.flag;
}
#line 7025 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 679:
#line 3342 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_rej.flag;
}
#line 7033 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 680:
#line 3346 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_unauth.flag;
}
#line 7041 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 681:
#line 3350 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_spy.flag;
}
#line 7049 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 682:
#line 3354 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_link.flag;
}
#line 7057 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 683:
#line 3358 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_link.flag;
}
#line 7065 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 684:
#line 3363 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes = 0;
}
#line 7073 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 688:
#line 3369 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_NOCTCP;
}
#line 7081 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 689:
#line 3373 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_DEAF;
}
#line 7089 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 690:
#line 3377 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_HIDECHANNELS;
}
#line 7097 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 691:
#line 3381 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_OPERWALL;
}
#line 7105 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 692:
#line 3385 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SERVNOTICE;
}
#line 7113 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 693:
#line 3389 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_INVISIBLE;
}
#line 7121 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 694:
#line 3393 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_WALLOP;
}
#line 7129 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 695:
#line 3397 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SOFTCALLERID;
}
#line 7137 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 696:
#line 3401 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CALLERID;
}
#line 7145 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 697:
#line 3405 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_LOCOPS;
}
#line 7153 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 698:
#line 3409 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_REGONLY;
}
#line 7161 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 699:
#line 3413 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SPY;
}
#line 7169 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 700:
#line 3418 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.disable_chmodes);
    ConfigFileEntry.disable_chmodes = xstrdup(yylval.string);
  }
}
#line 7181 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 701:
#line 3427 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.use_target_change = yylval.number;
}
#line 7189 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 702:
#line 3432 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard = (yyvsp[-1].number);
}
#line 7197 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 703:
#line 3437 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard_simple = (yyvsp[-1].number);
}
#line 7205 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 704:
#line 3442 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodcount = (yyvsp[-1].number);
}
#line 7213 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 705:
#line 3447 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodtime = (yyvsp[-1].number);
}
#line 7221 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 724:
#line 3471 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.disable_fake_channels = yylval.number;
}
#line 7229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 725:
#line 3476 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay = (yyvsp[-1].number);
}
#line 7237 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 726:
#line 3481 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay_channel = (yyvsp[-1].number);
}
#line 7245 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 727:
#line 3486 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_chans_per_user = (yyvsp[-1].number);
}
#line 7253 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 728:
#line 3491 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_chans_per_oper = (yyvsp[-1].number);
}
#line 7261 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 729:
#line 3496 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_bans = (yyvsp[-1].number);
}
#line 7269 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 730:
#line 3501 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_user_count = (yyvsp[-1].number);
}
#line 7277 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 731:
#line 3506 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_server_count = (yyvsp[-1].number);
}
#line 7285 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 732:
#line 3511 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_create_on_split = yylval.number;
}
#line 7293 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 733:
#line 3516 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_join_on_split = yylval.number;
}
#line 7301 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 734:
#line 3521 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodcount = yylval.number;
}
#line 7309 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 735:
#line 3526 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodtime = (yyvsp[-1].number);
}
#line 7317 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 736:
#line 3531 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.quiet_on_ban = yylval.number;
}
#line 7325 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 737:
#line 3536 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.invite_throttle = (yyvsp[-1].number);
}
#line 7333 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3556 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.flatten_links = yylval.number;
}
#line 7342 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3562 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.disable_remote_commands = yylval.number;
}
#line 7351 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3568 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_servers = yylval.number;
}
#line 7360 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3574 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_services = yylval.number;
}
#line 7369 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3580 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigServerHide.hidden_name);
    ConfigServerHide.hidden_name = xstrdup(yylval.string);
  }
}
#line 7381 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3589 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (((yyvsp[-1].number) > 0) && ConfigServerHide.links_disabled == 1)
    {
      eventAddIsh("write_links_file", write_links_file, NULL, (yyvsp[-1].number));
      ConfigServerHide.links_disabled = 0;
    }

    ConfigServerHide.links_delay = (yyvsp[-1].number);
  }
}
#line 7398 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3603 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hidden = yylval.number;
}
#line 7407 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3609 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_server_ips = yylval.number;
}
#line 7416 "conf_parser.c" /* yacc.c:1646  */
    break;


#line 7420 "conf_parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
